<%@page import="java.util.Arrays"%>
<%@page import="java.util.List"%>
<%@page import="com.liferay.portlet.asset.model.AssetCategory"%>
<%@page import="com.martico.portlet.activity.form.ActivityForm"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib uri="http://java.sun.com/portlet_2_0" prefix="portlet"%>
<%@ taglib uri="http://liferay.com/tld/ui" prefix="liferay-ui"%>
<%@ taglib uri="http://liferay.com/tld/theme" prefix="theme"%>
<%@ taglib uri="http://liferay.com/tld/portlet" prefix="liferay-portlet"%>
<%@ taglib uri="http://alloy.liferay.com/tld/aui" prefix="aui"%>

<portlet:defineObjects />
<theme:defineObjects />

<portlet:actionURL name="edit-activity" var="addActivityURL"
	escapeXml="false">
	<portlet:param name="namespace" value="activity" />
</portlet:actionURL>

<%
	long[] assetCategoryIds = (long[]) request
			.getAttribute("assetCategoryIds");
	List<AssetCategory> sectionCategories = (List<AssetCategory>) request
			.getAttribute("sectionCategories");
	List<AssetCategory> typeCategories = (List<AssetCategory>) request
			.getAttribute("typeCategories");
%>

<liferay-ui:header title="${title }" backURL="${backUrl }" />
<aui:form name="editActivityForm"
	action="<%=addActivityURL.toString()%>" method="post">
	<aui:model-context bean="${requestScope.activityForm}"
		model="<%=ActivityForm.class%>" />
	<aui:button-row>
		<aui:button type="submit" value="save" />
	</aui:button-row>

	<div class="clear"></div>
	<aui:input type="hidden" name="activityId"></aui:input>

	<aui:fieldset>
		<liferay-ui:header title="activity.basicInformation" />
		<aui:column columnWidth="33">
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-name-required"
					message="errors.requiredField" />
				<aui:input id="name" name="name" label="activity.name" type="text" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-responsible-required"
					message="errors.requiredField" />
				<aui:input id="responsible" name="responsible" type="text"
					label="activity.responsible" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-recipient-required"
					message="errors.requiredField" />
				<liferay-ui:error key="activity-recipient-number"
					message="errors.numberField" />
				<aui:input id="recipient" name="recipient" type="text"
					label="activity.recipient" />
			</aui:field-wrapper>
		</aui:column>
		<aui:column columnWidth="33">
			<aui:field-wrapper inlineField="false" cssClass="category relative">
				<aui:select label="activity.type" name="typeCategory"
					showEmptyOption="<%=true%>">
					<%
						for (AssetCategory category : typeCategories) {
					%>
					<aui:option value="<%=category.getCategoryId()%>"
						selected="<%=Arrays.binarySearch(
												assetCategoryIds,
												category.getCategoryId()) >= 0%>"><%=category.getName()%></aui:option>
					<%
						}
					%>
				</aui:select>
				<liferay-ui:error key="type-category-required"
					message="errors.requiredField" />
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.date">
				<liferay-ui:input-date yearRangeStart="2012" yearRangeEnd="2050"
					dayParam="activityDay" monthParam="activityMonth"
					yearParam="activityYear"
					dayValue="${requestScope.activityForm.activityDay }"
					monthValue="${requestScope.activityForm.activityMonth }"
					yearValue="${requestScope.activityForm.activityYear }" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-ages-required"
					message="errors.requiredField" />
				<liferay-ui:error key="activity-ages-number"
					message="errors.requiredField" />
				<aui:input id="ages" name="ages" label="activity.ages" type="text" />
			</aui:field-wrapper>
		</aui:column>
		<aui:column columnWidth="33">
			<aui:field-wrapper inlineField="false" cssClass="category relative">
				<aui:select label="activity.section" name="sectionCategory"
					showEmptyOption="<%=true%>">
					<%
						for (AssetCategory category : sectionCategories) {
					%>
					<aui:option value="<%=category.getCategoryId()%>"
						selected="<%=Arrays.binarySearch(
												assetCategoryIds,
												category.getCategoryId()) >= 0%>"><%=category.getName()%></aui:option>
					<%
						}
					%>
				</aui:select>

				<liferay-ui:error key="section-category-required"
					message="errors.requiredField" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-duration-required"
					message="errors.requiredField" />
				<liferay-ui:error key="activity-duration-number"
					message="errors.numberField" />
				<aui:input id="duration" name="duration" label="activity.duration"
					type="text" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-place-required"
					message="errors.requiredField" />
				<aui:input id="place" name="place" type="text"
					label="activity.place" />
			</aui:field-wrapper>
		</aui:column>
	</aui:fieldset>
	<aui:fieldset>
		<aui:column columnWidth="50" first="true">
			<liferay-ui:header title="activity.objectives" />
			<aui:field-wrapper>
				<liferay-ui:error key="activity-objectives-required"
					message="errors.requiredField" />
				<aui:input type="textarea" id="objectives" name="objectives" inputCssClass="bigTextArea"
					label="" />
			</aui:field-wrapper>
			</aui:column>
		<aui:column columnWidth="50">
			<liferay-ui:header title="activity.budget.title" />
			<aui:field-wrapper>
				<liferay-ui:error key="activity-equipmentToBuy-required"
					message="errors.requiredField" />
				<aui:input type="textarea" id="equipmentToBuy" name="equipmentToBuy"
					label="activity.equipmentToBuy" />
			</aui:field-wrapper>
			<aui:field-wrapper cssClass="relative">
				<liferay-ui:error key="activity-budget-number"
					message="errors.numberField" />
				<aui:input id="budget" name="budget" label="activity.budget"
					type="text" />
			</aui:field-wrapper>
		</aui:column>
	</aui:fieldset>
	<aui:fieldset>
		<liferay-ui:header title="activity.description" />
		<aui:field-wrapper>
			<liferay-ui:error key="activity-description-required"
				message="errors.requiredField" />
			<aui:input type="textarea" id="description" name="description" inputCssClass="bigTextArea"
				label="" />
		</aui:field-wrapper>
	</aui:fieldset>
	<aui:fieldset>
		<aui:column columnWidth="50" first="true">
			<liferay-ui:header title="activity.personal" />
			<aui:field-wrapper>
				<liferay-ui:error key="activity-personal-required"
					message="errors.requiredField" />
				<aui:input type="textarea" id="personal" name="personal" inputCssClass="bigTextArea"
					label="" />
			</aui:field-wrapper>
		</aui:column>
		<aui:column columnWidth="50">
			<liferay-ui:header title="activity.material" />
			<aui:field-wrapper>
				<liferay-ui:error key="activity-material-required"
					message="errors.requiredField" />
				<aui:input type="textarea" id="material" name="material" inputCssClass="bigTextArea"
					label="" />
			</aui:field-wrapper>
			</aui:column>
		<aui:field-wrapper>
			<liferay-ui:header title="activity.observation" />
			<liferay-ui:error key="activity-observation-required"
				message="errors.requiredField" />
			<aui:input type="textarea" id="observation" name="observation"
				label="" />
		</aui:field-wrapper>
	</aui:fieldset>
	<div class="clear"></div>
</aui:form>