<%@page import="com.martico.portlet.util.ActionKeys"%>
<%@page import="com.martico.portlet.util.PortletKeys"%>
<%@page import="com.liferay.portal.service.permission.PortletPermissionUtil"%>
<%@page import="com.martico.portlet.activity.search.ActivitySearchContainer"%>
<%@page import="com.martico.portlet.util.ArrayUtils"%>
<%@page import="com.martico.portlet.activity.util.ActivityUtil"%>
<%@page import="javax.portlet.PortletURL"%>
<%@page import="com.liferay.portal.kernel.util.PropsKeys"%>
<%@page import="java.text.DateFormat"%>
<%@page import="com.liferay.portal.kernel.util.DateFormatFactoryUtil"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib uri="http://java.sun.com/portlet_2_0" prefix="portlet"%>
<%@ taglib uri="http://liferay.com/tld/ui" prefix="liferay-ui"%>
<%@ taglib uri="http://liferay.com/tld/theme" prefix="theme"%>
<%@ taglib uri="http://liferay.com/tld/portlet" prefix="liferay-portlet"%>
<%@ taglib uri="http://alloy.liferay.com/tld/aui" prefix="aui" %>

<portlet:defineObjects />
<theme:defineObjects />

<portlet:renderURL var="addActivityURL" escapeXml="false">
	<portlet:param name="namespace" value="activity" />
	<portlet:param name="view" value="edit-activity" />
</portlet:renderURL>

<portlet:renderURL var="searchActivityURL" escapeXml="false">
	<portlet:param name="namespace" value="activity" />
	<portlet:param name="view" value="list-activity" />
</portlet:renderURL>

<liferay-ui:header title="${title }" />
<liferay-ui:success key="activity.delete.success" message="activity.delete.success"/>
<aui:button-row>
	<c:if test="<%=PortletPermissionUtil.contains(permissionChecker, plid, PortletKeys.MARTICO_ACTIVITY_PORTLET, ActionKeys.CREATE_ACTIVITY)%>">
		<aui:button onClick="${addActivityURL}"
			value="activity.addActivity" />
	</c:if>
</aui:button-row>
<%
DateFormat dateFormat = DateFormatFactoryUtil.getDate(themeDisplay.getLocale());
PortletURL viewURL = renderResponse.createRenderURL();
viewURL.setParameter("namespace", "activity");
viewURL.setParameter("view", "view-activity");

ActivitySearchContainer searchController = (ActivitySearchContainer)request.getAttribute("searchContainer");
long[] allResults = ArrayUtils.getIdArray(searchController.getResults());
%>
<aui:form method="post" action="<%=searchActivityURL.toString()%>" name="fm">
	<liferay-ui:search-container searchContainer="${searchContainer}"
			emptyResultsMessage="message.noResultsFound">
	
		<liferay-ui:search-form page="/WEB-INF/jsp/activity/searchForm.jsp"
			searchContainer="${searchContainer}"
			servletContext="<%=this.getServletContext()%>">
		</liferay-ui:search-form>
		<div class="separator"></div>
		<liferay-ui:search-container-results results="${searchContainer.results}"
			total="${searchContainer.total}" />
		<liferay-ui:search-container-row
			className="com.martico.model.Activity" keyProperty="activityId"
			modelVar="activity">
			<% viewURL.setParameter("activityId", String.valueOf(activity.getActivityId())); %>
			<liferay-ui:search-container-column-text name="activity.name"
				property="name" orderable="true" href="<%=viewURL.toString()%>" orderableProperty="name"/>		
			<liferay-ui:search-container-column-text name="activity.type"
				 orderable="true" href="<%=viewURL.toString()%>" value="<%=ActivityUtil.getTypeCategory(themeDisplay, activity) %>"/>
			<liferay-ui:search-container-column-text name="activity.section"
				 orderable="true" href="<%=viewURL.toString()%>" value="<%=ActivityUtil.getSectionCategory(themeDisplay, activity) %>"/>
			<liferay-ui:search-container-column-text name="activity.date"
				 orderable="true" href="<%=viewURL.toString()%>" value="<%=dateFormat.format(activity.getDate()) %>"/>
	
		</liferay-ui:search-container-row>
		<liferay-ui:search-iterator />
		<%
			if(searchController.getTotal()>0){
			String pdfIconPath = themeDisplay.getPathThemeImages()  + "/file_system/small/pdf.png";
		%>
		<liferay-ui:icon label="<%=false%>" message="export" src="<%=pdfIconPath%>" url="javascript:exportToPDF()" /> 
		<%
	 		}
	 	%>
	</liferay-ui:search-container >
</aui:form>

<aui:form name="exportForm" method="post" action="${printUrl }">
		<aui:input name="activityIds" type="hidden" value="<%=ArrayUtils.arrayToString(allResults)%>"/>
</aui:form>

<script type="text/javascript">

function exportToPDF() {
	var exportForm = AUI().one('#<portlet:namespace />exportForm');
	exportForm.submit();
}
</script>