<%@page import="com.liferay.portal.kernel.util.HtmlUtil"%>
<%@page import="org.springframework.web.util.HtmlUtils"%>
<%@page import="com.liferay.portal.service.permission.PortletPermissionUtil"%>
<%@page import="com.martico.portlet.util.PortletKeys"%>
<%@page import="com.martico.portlet.util.ActionKeys"%>
<%@page import="com.martico.portlet.util.DecimalFormatUtil"%>
<%@page import="com.martico.portlet.util.ResourceBundleUtil"%>
<%@page import="com.liferay.portal.kernel.language.LanguageUtil"%>
<%@page import="java.text.DateFormat"%>
<%@page import="com.liferay.portal.kernel.util.DateFormatFactoryUtil"%>
<%@page import="com.martico.model.Activity"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib uri="http://java.sun.com/portlet_2_0" prefix="portlet"%>
<%@ taglib uri="http://liferay.com/tld/ui" prefix="liferay-ui"%>
<%@ taglib uri="http://liferay.com/tld/theme" prefix="theme"%>
<%@ taglib uri="http://liferay.com/tld/portlet" prefix="liferay-portlet"%>
<%@ taglib uri="http://alloy.liferay.com/tld/aui" prefix="aui"%>

<portlet:defineObjects />
<theme:defineObjects />
<%
Activity activity = (Activity) request.getAttribute("activity"); 
DateFormat dateFormat = DateFormatFactoryUtil.getDate(themeDisplay.getLocale());
%>
<liferay-ui:header title="${title }" backURL="${backUrl }" />


<liferay-ui:success key="activity.save.success" message="activity.save.success"/>
<aui:button-row>
	<c:if test="<%=PortletPermissionUtil.contains(permissionChecker, plid, PortletKeys.MARTICO_ACTIVITY_PORTLET, ActionKeys.EDIT_ACTIVITY)%>">
		<aui:button onClick="${editUrl }" value="edit" />
	</c:if>
	<aui:button onClick="${printUrl }" value="print" />
	<c:if test="<%=PortletPermissionUtil.contains(permissionChecker, plid, PortletKeys.MARTICO_ACTIVITY_PORTLET, ActionKeys.DELETE_ACTIVITY)%>">
		<aui:button onClick="deleteActivity()" value="delete" />
	</c:if>
</aui:button-row>

<aui:form name="deleteActivityForm" method="post" action="${deleteUrl }">
	<aui:input type="hidden" name="activityId" value="${requestScope.activity.activityId}" />
</aui:form>
<div class="clear"></div>
<aui:layout>
	<aui:fieldset cssClass="rounded-box">
		<liferay-ui:header title="activity.basicInformation" />
		<aui:column columnWidth="33">
			<aui:field-wrapper label="activity.name" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.name} </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.responsible" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.responsible} </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.recipient" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.recipient}  </span>
			</aui:field-wrapper>
		</aui:column>
		<aui:column  columnWidth="33">
			<aui:field-wrapper label="activity.type" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.typeCategory} </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.date" inlineLabel="true">
				<span class="aui-field-element noeditable"> <%=dateFormat.format(activity.getDate()) %> </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.ages" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.ages}  </span>
			</aui:field-wrapper>
		</aui:column>
		<aui:column  columnWidth="33">
			<aui:field-wrapper label="activity.section" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.sectionCategory} </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.duration" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.duration}  </span>
			</aui:field-wrapper>
			<aui:field-wrapper label="activity.place" inlineLabel="true">
				<span class="aui-field-element noeditable"> ${requestScope.activity.place}  </span>
			</aui:field-wrapper>
		</aui:column>
	</aui:fieldset>
	<aui:fieldset cssClass="rounded-box">
		<aui:column columnWidth="50" first="true">
			<liferay-ui:header title="activity.objectives" />
			<span> ${requestScope.activity.objective}  </span>
		</aui:column>
		<aui:column columnWidth="50">
			<liferay-ui:header title="activity.budget.title" />
			<span> 
				<%=activity.getEquipmentToBuy().replaceAll("\n", "<br />") %>
			</span>
			<div>
				<span class="budgetTitle"><%=ResourceBundleUtil.getString(themeDisplay.getLocale(),"activitySheet","activity.budget") %>:</span> <span><%=DecimalFormatUtil.getCurrencyFormat(activity.getBudget()) %></span>
			</div>
		</aui:column>
	</aui:fieldset>
	<aui:fieldset cssClass="rounded-box">
		<liferay-ui:header title="activity.description" />
		<span>${requestScope.activity.description}</span>
	</aui:fieldset>
	<aui:fieldset cssClass="rounded-box">
		<aui:column columnWidth="50" first="true">
			<liferay-ui:header title="activity.personal" />
			<span>${requestScope.activity.personal}</span>
		</aui:column>
		<aui:column columnWidth="50">
			<liferay-ui:header title="activity.material" />
			<span>${requestScope.activity.material}</span>
		</aui:column>
	</aui:fieldset>
	<aui:fieldset cssClass="rounded-box">
		<liferay-ui:header title="activity.observation" />
			<span>${requestScope.activity.observation}</span>
	</aui:fieldset>
</aui:layout>

<script type="text/javascript">
	function deleteActivity() {
		var msg = '<liferay-ui:message key="activity.delete.confirm"/>';
		if (confirm(msg)) {
			var deleteForm = AUI().one('#<portlet:namespace />deleteActivityForm');
			deleteForm.submit();
		}
	}
</script>