/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import com.martico.service.ActivityLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author edusaldana
 */
public class ActivityClp extends BaseModelImpl<Activity> implements Activity {
	public ActivityClp() {
	}

	public Class<?> getModelClass() {
		return Activity.class;
	}

	public String getModelClassName() {
		return Activity.class.getName();
	}

	public long getPrimaryKey() {
		return _activityId;
	}

	public void setPrimaryKey(long primaryKey) {
		setActivityId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_activityId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityId", getActivityId());
		attributes.put("name", getName());
		attributes.put("responsible", getResponsible());
		attributes.put("date", getDate());
		attributes.put("duration", getDuration());
		attributes.put("recipient", getRecipient());
		attributes.put("ages", getAges());
		attributes.put("place", getPlace());
		attributes.put("objective", getObjective());
		attributes.put("equipmentToBuy", getEquipmentToBuy());
		attributes.put("budget", getBudget());
		attributes.put("description", getDescription());
		attributes.put("personal", getPersonal());
		attributes.put("material", getMaterial());
		attributes.put("observation", getObservation());
		attributes.put("companyId", getCompanyId());
		attributes.put("groupId", getGroupId());
		attributes.put("userId", getUserId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String responsible = (String)attributes.get("responsible");

		if (responsible != null) {
			setResponsible(responsible);
		}

		Date date = (Date)attributes.get("date");

		if (date != null) {
			setDate(date);
		}

		Integer duration = (Integer)attributes.get("duration");

		if (duration != null) {
			setDuration(duration);
		}

		Integer recipient = (Integer)attributes.get("recipient");

		if (recipient != null) {
			setRecipient(recipient);
		}

		String ages = (String)attributes.get("ages");

		if (ages != null) {
			setAges(ages);
		}

		String place = (String)attributes.get("place");

		if (place != null) {
			setPlace(place);
		}

		String objective = (String)attributes.get("objective");

		if (objective != null) {
			setObjective(objective);
		}

		String equipmentToBuy = (String)attributes.get("equipmentToBuy");

		if (equipmentToBuy != null) {
			setEquipmentToBuy(equipmentToBuy);
		}

		Float budget = (Float)attributes.get("budget");

		if (budget != null) {
			setBudget(budget);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		String personal = (String)attributes.get("personal");

		if (personal != null) {
			setPersonal(personal);
		}

		String material = (String)attributes.get("material");

		if (material != null) {
			setMaterial(material);
		}

		String observation = (String)attributes.get("observation");

		if (observation != null) {
			setObservation(observation);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}
	}

	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_activityId = activityId;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public String getResponsible() {
		return _responsible;
	}

	public void setResponsible(String responsible) {
		_responsible = responsible;
	}

	public Date getDate() {
		return _date;
	}

	public void setDate(Date date) {
		_date = date;
	}

	public Integer getDuration() {
		return _duration;
	}

	public void setDuration(Integer duration) {
		_duration = duration;
	}

	public Integer getRecipient() {
		return _recipient;
	}

	public void setRecipient(Integer recipient) {
		_recipient = recipient;
	}

	public String getAges() {
		return _ages;
	}

	public void setAges(String ages) {
		_ages = ages;
	}

	public String getPlace() {
		return _place;
	}

	public void setPlace(String place) {
		_place = place;
	}

	public String getObjective() {
		return _objective;
	}

	public void setObjective(String objective) {
		_objective = objective;
	}

	public String getEquipmentToBuy() {
		return _equipmentToBuy;
	}

	public void setEquipmentToBuy(String equipmentToBuy) {
		_equipmentToBuy = equipmentToBuy;
	}

	public Float getBudget() {
		return _budget;
	}

	public void setBudget(Float budget) {
		_budget = budget;
	}

	public String getDescription() {
		return _description;
	}

	public void setDescription(String description) {
		_description = description;
	}

	public String getPersonal() {
		return _personal;
	}

	public void setPersonal(String personal) {
		_personal = personal;
	}

	public String getMaterial() {
		return _material;
	}

	public void setMaterial(String material) {
		_material = material;
	}

	public String getObservation() {
		return _observation;
	}

	public void setObservation(String observation) {
		_observation = observation;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public BaseModel<?> getActivityRemoteModel() {
		return _activityRemoteModel;
	}

	public void setActivityRemoteModel(BaseModel<?> activityRemoteModel) {
		_activityRemoteModel = activityRemoteModel;
	}

	public void persist() throws SystemException {
		if (this.isNew()) {
			ActivityLocalServiceUtil.addActivity(this);
		}
		else {
			ActivityLocalServiceUtil.updateActivity(this);
		}
	}

	@Override
	public Activity toEscapedModel() {
		return (Activity)Proxy.newProxyInstance(Activity.class.getClassLoader(),
			new Class[] { Activity.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		ActivityClp clone = new ActivityClp();

		clone.setActivityId(getActivityId());
		clone.setName(getName());
		clone.setResponsible(getResponsible());
		clone.setDate(getDate());
		clone.setDuration(getDuration());
		clone.setRecipient(getRecipient());
		clone.setAges(getAges());
		clone.setPlace(getPlace());
		clone.setObjective(getObjective());
		clone.setEquipmentToBuy(getEquipmentToBuy());
		clone.setBudget(getBudget());
		clone.setDescription(getDescription());
		clone.setPersonal(getPersonal());
		clone.setMaterial(getMaterial());
		clone.setObservation(getObservation());
		clone.setCompanyId(getCompanyId());
		clone.setGroupId(getGroupId());
		clone.setUserId(getUserId());

		return clone;
	}

	public int compareTo(Activity activity) {
		long primaryKey = activity.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		ActivityClp activity = null;

		try {
			activity = (ActivityClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = activity.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(37);

		sb.append("{activityId=");
		sb.append(getActivityId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", responsible=");
		sb.append(getResponsible());
		sb.append(", date=");
		sb.append(getDate());
		sb.append(", duration=");
		sb.append(getDuration());
		sb.append(", recipient=");
		sb.append(getRecipient());
		sb.append(", ages=");
		sb.append(getAges());
		sb.append(", place=");
		sb.append(getPlace());
		sb.append(", objective=");
		sb.append(getObjective());
		sb.append(", equipmentToBuy=");
		sb.append(getEquipmentToBuy());
		sb.append(", budget=");
		sb.append(getBudget());
		sb.append(", description=");
		sb.append(getDescription());
		sb.append(", personal=");
		sb.append(getPersonal());
		sb.append(", material=");
		sb.append(getMaterial());
		sb.append(", observation=");
		sb.append(getObservation());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(58);

		sb.append("<model><model-name>");
		sb.append("com.martico.model.Activity");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>activityId</column-name><column-value><![CDATA[");
		sb.append(getActivityId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>responsible</column-name><column-value><![CDATA[");
		sb.append(getResponsible());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>date</column-name><column-value><![CDATA[");
		sb.append(getDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>duration</column-name><column-value><![CDATA[");
		sb.append(getDuration());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>recipient</column-name><column-value><![CDATA[");
		sb.append(getRecipient());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ages</column-name><column-value><![CDATA[");
		sb.append(getAges());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>place</column-name><column-value><![CDATA[");
		sb.append(getPlace());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>objective</column-name><column-value><![CDATA[");
		sb.append(getObjective());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>equipmentToBuy</column-name><column-value><![CDATA[");
		sb.append(getEquipmentToBuy());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>budget</column-name><column-value><![CDATA[");
		sb.append(getBudget());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>description</column-name><column-value><![CDATA[");
		sb.append(getDescription());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>personal</column-name><column-value><![CDATA[");
		sb.append(getPersonal());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>material</column-name><column-value><![CDATA[");
		sb.append(getMaterial());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>observation</column-name><column-value><![CDATA[");
		sb.append(getObservation());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _activityId;
	private String _name;
	private String _responsible;
	private Date _date;
	private Integer _duration;
	private Integer _recipient;
	private String _ages;
	private String _place;
	private String _objective;
	private String _equipmentToBuy;
	private Float _budget;
	private String _description;
	private String _personal;
	private String _material;
	private String _observation;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private BaseModel<?> _activityRemoteModel;
}