/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Activity service. Represents a row in the &quot;martico_Activity&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.martico.model.impl.ActivityModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.martico.model.impl.ActivityImpl}.
 * </p>
 *
 * @author edusaldana
 * @see Activity
 * @see com.martico.model.impl.ActivityImpl
 * @see com.martico.model.impl.ActivityModelImpl
 * @generated
 */
public interface ActivityModel extends BaseModel<Activity> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a activity model instance should use the {@link Activity} interface instead.
	 */

	/**
	 * Returns the primary key of this activity.
	 *
	 * @return the primary key of this activity
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this activity.
	 *
	 * @param primaryKey the primary key of this activity
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the activity ID of this activity.
	 *
	 * @return the activity ID of this activity
	 */
	public long getActivityId();

	/**
	 * Sets the activity ID of this activity.
	 *
	 * @param activityId the activity ID of this activity
	 */
	public void setActivityId(long activityId);

	/**
	 * Returns the name of this activity.
	 *
	 * @return the name of this activity
	 */
	@AutoEscape
	public String getName();

	/**
	 * Sets the name of this activity.
	 *
	 * @param name the name of this activity
	 */
	public void setName(String name);

	/**
	 * Returns the responsible of this activity.
	 *
	 * @return the responsible of this activity
	 */
	@AutoEscape
	public String getResponsible();

	/**
	 * Sets the responsible of this activity.
	 *
	 * @param responsible the responsible of this activity
	 */
	public void setResponsible(String responsible);

	/**
	 * Returns the date of this activity.
	 *
	 * @return the date of this activity
	 */
	public Date getDate();

	/**
	 * Sets the date of this activity.
	 *
	 * @param date the date of this activity
	 */
	public void setDate(Date date);

	/**
	 * Returns the duration of this activity.
	 *
	 * @return the duration of this activity
	 */
	public Integer getDuration();

	/**
	 * Sets the duration of this activity.
	 *
	 * @param duration the duration of this activity
	 */
	public void setDuration(Integer duration);

	/**
	 * Returns the recipient of this activity.
	 *
	 * @return the recipient of this activity
	 */
	public Integer getRecipient();

	/**
	 * Sets the recipient of this activity.
	 *
	 * @param recipient the recipient of this activity
	 */
	public void setRecipient(Integer recipient);

	/**
	 * Returns the ages of this activity.
	 *
	 * @return the ages of this activity
	 */
	@AutoEscape
	public String getAges();

	/**
	 * Sets the ages of this activity.
	 *
	 * @param ages the ages of this activity
	 */
	public void setAges(String ages);

	/**
	 * Returns the place of this activity.
	 *
	 * @return the place of this activity
	 */
	@AutoEscape
	public String getPlace();

	/**
	 * Sets the place of this activity.
	 *
	 * @param place the place of this activity
	 */
	public void setPlace(String place);

	/**
	 * Returns the objective of this activity.
	 *
	 * @return the objective of this activity
	 */
	@AutoEscape
	public String getObjective();

	/**
	 * Sets the objective of this activity.
	 *
	 * @param objective the objective of this activity
	 */
	public void setObjective(String objective);

	/**
	 * Returns the equipment to buy of this activity.
	 *
	 * @return the equipment to buy of this activity
	 */
	@AutoEscape
	public String getEquipmentToBuy();

	/**
	 * Sets the equipment to buy of this activity.
	 *
	 * @param equipmentToBuy the equipment to buy of this activity
	 */
	public void setEquipmentToBuy(String equipmentToBuy);

	/**
	 * Returns the budget of this activity.
	 *
	 * @return the budget of this activity
	 */
	public Float getBudget();

	/**
	 * Sets the budget of this activity.
	 *
	 * @param budget the budget of this activity
	 */
	public void setBudget(Float budget);

	/**
	 * Returns the description of this activity.
	 *
	 * @return the description of this activity
	 */
	@AutoEscape
	public String getDescription();

	/**
	 * Sets the description of this activity.
	 *
	 * @param description the description of this activity
	 */
	public void setDescription(String description);

	/**
	 * Returns the personal of this activity.
	 *
	 * @return the personal of this activity
	 */
	@AutoEscape
	public String getPersonal();

	/**
	 * Sets the personal of this activity.
	 *
	 * @param personal the personal of this activity
	 */
	public void setPersonal(String personal);

	/**
	 * Returns the material of this activity.
	 *
	 * @return the material of this activity
	 */
	@AutoEscape
	public String getMaterial();

	/**
	 * Sets the material of this activity.
	 *
	 * @param material the material of this activity
	 */
	public void setMaterial(String material);

	/**
	 * Returns the observation of this activity.
	 *
	 * @return the observation of this activity
	 */
	@AutoEscape
	public String getObservation();

	/**
	 * Sets the observation of this activity.
	 *
	 * @param observation the observation of this activity
	 */
	public void setObservation(String observation);

	/**
	 * Returns the company ID of this activity.
	 *
	 * @return the company ID of this activity
	 */
	public long getCompanyId();

	/**
	 * Sets the company ID of this activity.
	 *
	 * @param companyId the company ID of this activity
	 */
	public void setCompanyId(long companyId);

	/**
	 * Returns the group ID of this activity.
	 *
	 * @return the group ID of this activity
	 */
	public long getGroupId();

	/**
	 * Sets the group ID of this activity.
	 *
	 * @param groupId the group ID of this activity
	 */
	public void setGroupId(long groupId);

	/**
	 * Returns the user ID of this activity.
	 *
	 * @return the user ID of this activity
	 */
	public long getUserId();

	/**
	 * Sets the user ID of this activity.
	 *
	 * @param userId the user ID of this activity
	 */
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this activity.
	 *
	 * @return the user uuid of this activity
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this activity.
	 *
	 * @param userUuid the user uuid of this activity
	 */
	public void setUserUuid(String userUuid);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Activity activity);

	public int hashCode();

	public CacheModel<Activity> toCacheModel();

	public Activity toEscapedModel();

	public String toString();

	public String toXmlString();
}