/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;

import com.martico.service.ActivityObjectiveLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.util.HashMap;
import java.util.Map;

/**
 * @author edusaldana
 */
public class ActivityObjectiveClp extends BaseModelImpl<ActivityObjective>
	implements ActivityObjective {
	public ActivityObjectiveClp() {
	}

	public Class<?> getModelClass() {
		return ActivityObjective.class;
	}

	public String getModelClassName() {
		return ActivityObjective.class.getName();
	}

	public long getPrimaryKey() {
		return _activityObjectiveId;
	}

	public void setPrimaryKey(long primaryKey) {
		setActivityObjectiveId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_activityObjectiveId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityObjectiveId", getActivityObjectiveId());
		attributes.put("name", getName());
		attributes.put("activityId", getActivityId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityObjectiveId = (Long)attributes.get("activityObjectiveId");

		if (activityObjectiveId != null) {
			setActivityObjectiveId(activityObjectiveId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}
	}

	public long getActivityObjectiveId() {
		return _activityObjectiveId;
	}

	public void setActivityObjectiveId(long activityObjectiveId) {
		_activityObjectiveId = activityObjectiveId;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_activityId = activityId;
	}

	public BaseModel<?> getActivityObjectiveRemoteModel() {
		return _activityObjectiveRemoteModel;
	}

	public void setActivityObjectiveRemoteModel(
		BaseModel<?> activityObjectiveRemoteModel) {
		_activityObjectiveRemoteModel = activityObjectiveRemoteModel;
	}

	public void persist() throws SystemException {
		if (this.isNew()) {
			ActivityObjectiveLocalServiceUtil.addActivityObjective(this);
		}
		else {
			ActivityObjectiveLocalServiceUtil.updateActivityObjective(this);
		}
	}

	@Override
	public ActivityObjective toEscapedModel() {
		return (ActivityObjective)Proxy.newProxyInstance(ActivityObjective.class.getClassLoader(),
			new Class[] { ActivityObjective.class },
			new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		ActivityObjectiveClp clone = new ActivityObjectiveClp();

		clone.setActivityObjectiveId(getActivityObjectiveId());
		clone.setName(getName());
		clone.setActivityId(getActivityId());

		return clone;
	}

	public int compareTo(ActivityObjective activityObjective) {
		long primaryKey = activityObjective.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		ActivityObjectiveClp activityObjective = null;

		try {
			activityObjective = (ActivityObjectiveClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = activityObjective.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(7);

		sb.append("{activityObjectiveId=");
		sb.append(getActivityObjectiveId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", activityId=");
		sb.append(getActivityId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(13);

		sb.append("<model><model-name>");
		sb.append("com.martico.model.ActivityObjective");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>activityObjectiveId</column-name><column-value><![CDATA[");
		sb.append(getActivityObjectiveId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>activityId</column-name><column-value><![CDATA[");
		sb.append(getActivityId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _activityObjectiveId;
	private String _name;
	private long _activityId;
	private BaseModel<?> _activityObjectiveRemoteModel;
}