/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the ActivityObjective service. Represents a row in the &quot;martico_ActivityObjective&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.martico.model.impl.ActivityObjectiveModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.martico.model.impl.ActivityObjectiveImpl}.
 * </p>
 *
 * @author edusaldana
 * @see ActivityObjective
 * @see com.martico.model.impl.ActivityObjectiveImpl
 * @see com.martico.model.impl.ActivityObjectiveModelImpl
 * @generated
 */
public interface ActivityObjectiveModel extends BaseModel<ActivityObjective> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a activity objective model instance should use the {@link ActivityObjective} interface instead.
	 */

	/**
	 * Returns the primary key of this activity objective.
	 *
	 * @return the primary key of this activity objective
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this activity objective.
	 *
	 * @param primaryKey the primary key of this activity objective
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the activity objective ID of this activity objective.
	 *
	 * @return the activity objective ID of this activity objective
	 */
	public long getActivityObjectiveId();

	/**
	 * Sets the activity objective ID of this activity objective.
	 *
	 * @param activityObjectiveId the activity objective ID of this activity objective
	 */
	public void setActivityObjectiveId(long activityObjectiveId);

	/**
	 * Returns the name of this activity objective.
	 *
	 * @return the name of this activity objective
	 */
	@AutoEscape
	public String getName();

	/**
	 * Sets the name of this activity objective.
	 *
	 * @param name the name of this activity objective
	 */
	public void setName(String name);

	/**
	 * Returns the activity ID of this activity objective.
	 *
	 * @return the activity ID of this activity objective
	 */
	public long getActivityId();

	/**
	 * Sets the activity ID of this activity objective.
	 *
	 * @param activityId the activity ID of this activity objective
	 */
	public void setActivityId(long activityId);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(ActivityObjective activityObjective);

	public int hashCode();

	public CacheModel<ActivityObjective> toCacheModel();

	public ActivityObjective toEscapedModel();

	public String toString();

	public String toXmlString();
}