/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.martico.service.http.ActivityObjectiveServiceSoap}.
 *
 * @author    edusaldana
 * @see       com.martico.service.http.ActivityObjectiveServiceSoap
 * @generated
 */
public class ActivityObjectiveSoap implements Serializable {
	public static ActivityObjectiveSoap toSoapModel(ActivityObjective model) {
		ActivityObjectiveSoap soapModel = new ActivityObjectiveSoap();

		soapModel.setActivityObjectiveId(model.getActivityObjectiveId());
		soapModel.setName(model.getName());
		soapModel.setActivityId(model.getActivityId());

		return soapModel;
	}

	public static ActivityObjectiveSoap[] toSoapModels(
		ActivityObjective[] models) {
		ActivityObjectiveSoap[] soapModels = new ActivityObjectiveSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static ActivityObjectiveSoap[][] toSoapModels(
		ActivityObjective[][] models) {
		ActivityObjectiveSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new ActivityObjectiveSoap[models.length][models[0].length];
		}
		else {
			soapModels = new ActivityObjectiveSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static ActivityObjectiveSoap[] toSoapModels(
		List<ActivityObjective> models) {
		List<ActivityObjectiveSoap> soapModels = new ArrayList<ActivityObjectiveSoap>(models.size());

		for (ActivityObjective model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new ActivityObjectiveSoap[soapModels.size()]);
	}

	public ActivityObjectiveSoap() {
	}

	public long getPrimaryKey() {
		return _activityObjectiveId;
	}

	public void setPrimaryKey(long pk) {
		setActivityObjectiveId(pk);
	}

	public long getActivityObjectiveId() {
		return _activityObjectiveId;
	}

	public void setActivityObjectiveId(long activityObjectiveId) {
		_activityObjectiveId = activityObjectiveId;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_activityId = activityId;
	}

	private long _activityObjectiveId;
	private String _name;
	private long _activityId;
}