/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.model.ModelWrapper;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link ActivityObjective}.
 * </p>
 *
 * @author    edusaldana
 * @see       ActivityObjective
 * @generated
 */
public class ActivityObjectiveWrapper implements ActivityObjective,
	ModelWrapper<ActivityObjective> {
	public ActivityObjectiveWrapper(ActivityObjective activityObjective) {
		_activityObjective = activityObjective;
	}

	public Class<?> getModelClass() {
		return ActivityObjective.class;
	}

	public String getModelClassName() {
		return ActivityObjective.class.getName();
	}

	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityObjectiveId", getActivityObjectiveId());
		attributes.put("name", getName());
		attributes.put("activityId", getActivityId());

		return attributes;
	}

	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityObjectiveId = (Long)attributes.get("activityObjectiveId");

		if (activityObjectiveId != null) {
			setActivityObjectiveId(activityObjectiveId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}
	}

	/**
	* Returns the primary key of this activity objective.
	*
	* @return the primary key of this activity objective
	*/
	public long getPrimaryKey() {
		return _activityObjective.getPrimaryKey();
	}

	/**
	* Sets the primary key of this activity objective.
	*
	* @param primaryKey the primary key of this activity objective
	*/
	public void setPrimaryKey(long primaryKey) {
		_activityObjective.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the activity objective ID of this activity objective.
	*
	* @return the activity objective ID of this activity objective
	*/
	public long getActivityObjectiveId() {
		return _activityObjective.getActivityObjectiveId();
	}

	/**
	* Sets the activity objective ID of this activity objective.
	*
	* @param activityObjectiveId the activity objective ID of this activity objective
	*/
	public void setActivityObjectiveId(long activityObjectiveId) {
		_activityObjective.setActivityObjectiveId(activityObjectiveId);
	}

	/**
	* Returns the name of this activity objective.
	*
	* @return the name of this activity objective
	*/
	public java.lang.String getName() {
		return _activityObjective.getName();
	}

	/**
	* Sets the name of this activity objective.
	*
	* @param name the name of this activity objective
	*/
	public void setName(java.lang.String name) {
		_activityObjective.setName(name);
	}

	/**
	* Returns the activity ID of this activity objective.
	*
	* @return the activity ID of this activity objective
	*/
	public long getActivityId() {
		return _activityObjective.getActivityId();
	}

	/**
	* Sets the activity ID of this activity objective.
	*
	* @param activityId the activity ID of this activity objective
	*/
	public void setActivityId(long activityId) {
		_activityObjective.setActivityId(activityId);
	}

	public boolean isNew() {
		return _activityObjective.isNew();
	}

	public void setNew(boolean n) {
		_activityObjective.setNew(n);
	}

	public boolean isCachedModel() {
		return _activityObjective.isCachedModel();
	}

	public void setCachedModel(boolean cachedModel) {
		_activityObjective.setCachedModel(cachedModel);
	}

	public boolean isEscapedModel() {
		return _activityObjective.isEscapedModel();
	}

	public java.io.Serializable getPrimaryKeyObj() {
		return _activityObjective.getPrimaryKeyObj();
	}

	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_activityObjective.setPrimaryKeyObj(primaryKeyObj);
	}

	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _activityObjective.getExpandoBridge();
	}

	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_activityObjective.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new ActivityObjectiveWrapper((ActivityObjective)_activityObjective.clone());
	}

	public int compareTo(com.martico.model.ActivityObjective activityObjective) {
		return _activityObjective.compareTo(activityObjective);
	}

	@Override
	public int hashCode() {
		return _activityObjective.hashCode();
	}

	public com.liferay.portal.model.CacheModel<com.martico.model.ActivityObjective> toCacheModel() {
		return _activityObjective.toCacheModel();
	}

	public com.martico.model.ActivityObjective toEscapedModel() {
		return new ActivityObjectiveWrapper(_activityObjective.toEscapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _activityObjective.toString();
	}

	public java.lang.String toXmlString() {
		return _activityObjective.toXmlString();
	}

	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_activityObjective.persist();
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedModel}
	 */
	public ActivityObjective getWrappedActivityObjective() {
		return _activityObjective;
	}

	public ActivityObjective getWrappedModel() {
		return _activityObjective;
	}

	public void resetOriginalValues() {
		_activityObjective.resetOriginalValues();
	}

	private ActivityObjective _activityObjective;
}