/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link com.martico.service.http.ActivityServiceSoap}.
 *
 * @author    edusaldana
 * @see       com.martico.service.http.ActivityServiceSoap
 * @generated
 */
public class ActivitySoap implements Serializable {
	public static ActivitySoap toSoapModel(Activity model) {
		ActivitySoap soapModel = new ActivitySoap();

		soapModel.setActivityId(model.getActivityId());
		soapModel.setName(model.getName());
		soapModel.setResponsible(model.getResponsible());
		soapModel.setDate(model.getDate());
		soapModel.setDuration(model.getDuration());
		soapModel.setRecipient(model.getRecipient());
		soapModel.setAges(model.getAges());
		soapModel.setPlace(model.getPlace());
		soapModel.setObjective(model.getObjective());
		soapModel.setEquipmentToBuy(model.getEquipmentToBuy());
		soapModel.setBudget(model.getBudget());
		soapModel.setDescription(model.getDescription());
		soapModel.setPersonal(model.getPersonal());
		soapModel.setMaterial(model.getMaterial());
		soapModel.setObservation(model.getObservation());
		soapModel.setCompanyId(model.getCompanyId());
		soapModel.setGroupId(model.getGroupId());
		soapModel.setUserId(model.getUserId());

		return soapModel;
	}

	public static ActivitySoap[] toSoapModels(Activity[] models) {
		ActivitySoap[] soapModels = new ActivitySoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static ActivitySoap[][] toSoapModels(Activity[][] models) {
		ActivitySoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new ActivitySoap[models.length][models[0].length];
		}
		else {
			soapModels = new ActivitySoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static ActivitySoap[] toSoapModels(List<Activity> models) {
		List<ActivitySoap> soapModels = new ArrayList<ActivitySoap>(models.size());

		for (Activity model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new ActivitySoap[soapModels.size()]);
	}

	public ActivitySoap() {
	}

	public long getPrimaryKey() {
		return _activityId;
	}

	public void setPrimaryKey(long pk) {
		setActivityId(pk);
	}

	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_activityId = activityId;
	}

	public String getName() {
		return _name;
	}

	public void setName(String name) {
		_name = name;
	}

	public String getResponsible() {
		return _responsible;
	}

	public void setResponsible(String responsible) {
		_responsible = responsible;
	}

	public Date getDate() {
		return _date;
	}

	public void setDate(Date date) {
		_date = date;
	}

	public Integer getDuration() {
		return _duration;
	}

	public void setDuration(Integer duration) {
		_duration = duration;
	}

	public Integer getRecipient() {
		return _recipient;
	}

	public void setRecipient(Integer recipient) {
		_recipient = recipient;
	}

	public String getAges() {
		return _ages;
	}

	public void setAges(String ages) {
		_ages = ages;
	}

	public String getPlace() {
		return _place;
	}

	public void setPlace(String place) {
		_place = place;
	}

	public String getObjective() {
		return _objective;
	}

	public void setObjective(String objective) {
		_objective = objective;
	}

	public String getEquipmentToBuy() {
		return _equipmentToBuy;
	}

	public void setEquipmentToBuy(String equipmentToBuy) {
		_equipmentToBuy = equipmentToBuy;
	}

	public Float getBudget() {
		return _budget;
	}

	public void setBudget(Float budget) {
		_budget = budget;
	}

	public String getDescription() {
		return _description;
	}

	public void setDescription(String description) {
		_description = description;
	}

	public String getPersonal() {
		return _personal;
	}

	public void setPersonal(String personal) {
		_personal = personal;
	}

	public String getMaterial() {
		return _material;
	}

	public void setMaterial(String material) {
		_material = material;
	}

	public String getObservation() {
		return _observation;
	}

	public void setObservation(String observation) {
		_observation = observation;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	private long _activityId;
	private String _name;
	private String _responsible;
	private Date _date;
	private Integer _duration;
	private Integer _recipient;
	private String _ages;
	private String _place;
	private String _objective;
	private String _equipmentToBuy;
	private Float _budget;
	private String _description;
	private String _personal;
	private String _material;
	private String _observation;
	private long _companyId;
	private long _groupId;
	private long _userId;
}