/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model;

import com.liferay.portal.model.ModelWrapper;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link Activity}.
 * </p>
 *
 * @author    edusaldana
 * @see       Activity
 * @generated
 */
public class ActivityWrapper implements Activity, ModelWrapper<Activity> {
	public ActivityWrapper(Activity activity) {
		_activity = activity;
	}

	public Class<?> getModelClass() {
		return Activity.class;
	}

	public String getModelClassName() {
		return Activity.class.getName();
	}

	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityId", getActivityId());
		attributes.put("name", getName());
		attributes.put("responsible", getResponsible());
		attributes.put("date", getDate());
		attributes.put("duration", getDuration());
		attributes.put("recipient", getRecipient());
		attributes.put("ages", getAges());
		attributes.put("place", getPlace());
		attributes.put("objective", getObjective());
		attributes.put("equipmentToBuy", getEquipmentToBuy());
		attributes.put("budget", getBudget());
		attributes.put("description", getDescription());
		attributes.put("personal", getPersonal());
		attributes.put("material", getMaterial());
		attributes.put("observation", getObservation());
		attributes.put("companyId", getCompanyId());
		attributes.put("groupId", getGroupId());
		attributes.put("userId", getUserId());

		return attributes;
	}

	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String responsible = (String)attributes.get("responsible");

		if (responsible != null) {
			setResponsible(responsible);
		}

		Date date = (Date)attributes.get("date");

		if (date != null) {
			setDate(date);
		}

		Integer duration = (Integer)attributes.get("duration");

		if (duration != null) {
			setDuration(duration);
		}

		Integer recipient = (Integer)attributes.get("recipient");

		if (recipient != null) {
			setRecipient(recipient);
		}

		String ages = (String)attributes.get("ages");

		if (ages != null) {
			setAges(ages);
		}

		String place = (String)attributes.get("place");

		if (place != null) {
			setPlace(place);
		}

		String objective = (String)attributes.get("objective");

		if (objective != null) {
			setObjective(objective);
		}

		String equipmentToBuy = (String)attributes.get("equipmentToBuy");

		if (equipmentToBuy != null) {
			setEquipmentToBuy(equipmentToBuy);
		}

		Float budget = (Float)attributes.get("budget");

		if (budget != null) {
			setBudget(budget);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		String personal = (String)attributes.get("personal");

		if (personal != null) {
			setPersonal(personal);
		}

		String material = (String)attributes.get("material");

		if (material != null) {
			setMaterial(material);
		}

		String observation = (String)attributes.get("observation");

		if (observation != null) {
			setObservation(observation);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}
	}

	/**
	* Returns the primary key of this activity.
	*
	* @return the primary key of this activity
	*/
	public long getPrimaryKey() {
		return _activity.getPrimaryKey();
	}

	/**
	* Sets the primary key of this activity.
	*
	* @param primaryKey the primary key of this activity
	*/
	public void setPrimaryKey(long primaryKey) {
		_activity.setPrimaryKey(primaryKey);
	}

	/**
	* Returns the activity ID of this activity.
	*
	* @return the activity ID of this activity
	*/
	public long getActivityId() {
		return _activity.getActivityId();
	}

	/**
	* Sets the activity ID of this activity.
	*
	* @param activityId the activity ID of this activity
	*/
	public void setActivityId(long activityId) {
		_activity.setActivityId(activityId);
	}

	/**
	* Returns the name of this activity.
	*
	* @return the name of this activity
	*/
	public java.lang.String getName() {
		return _activity.getName();
	}

	/**
	* Sets the name of this activity.
	*
	* @param name the name of this activity
	*/
	public void setName(java.lang.String name) {
		_activity.setName(name);
	}

	/**
	* Returns the responsible of this activity.
	*
	* @return the responsible of this activity
	*/
	public java.lang.String getResponsible() {
		return _activity.getResponsible();
	}

	/**
	* Sets the responsible of this activity.
	*
	* @param responsible the responsible of this activity
	*/
	public void setResponsible(java.lang.String responsible) {
		_activity.setResponsible(responsible);
	}

	/**
	* Returns the date of this activity.
	*
	* @return the date of this activity
	*/
	public java.util.Date getDate() {
		return _activity.getDate();
	}

	/**
	* Sets the date of this activity.
	*
	* @param date the date of this activity
	*/
	public void setDate(java.util.Date date) {
		_activity.setDate(date);
	}

	/**
	* Returns the duration of this activity.
	*
	* @return the duration of this activity
	*/
	public java.lang.Integer getDuration() {
		return _activity.getDuration();
	}

	/**
	* Sets the duration of this activity.
	*
	* @param duration the duration of this activity
	*/
	public void setDuration(java.lang.Integer duration) {
		_activity.setDuration(duration);
	}

	/**
	* Returns the recipient of this activity.
	*
	* @return the recipient of this activity
	*/
	public java.lang.Integer getRecipient() {
		return _activity.getRecipient();
	}

	/**
	* Sets the recipient of this activity.
	*
	* @param recipient the recipient of this activity
	*/
	public void setRecipient(java.lang.Integer recipient) {
		_activity.setRecipient(recipient);
	}

	/**
	* Returns the ages of this activity.
	*
	* @return the ages of this activity
	*/
	public java.lang.String getAges() {
		return _activity.getAges();
	}

	/**
	* Sets the ages of this activity.
	*
	* @param ages the ages of this activity
	*/
	public void setAges(java.lang.String ages) {
		_activity.setAges(ages);
	}

	/**
	* Returns the place of this activity.
	*
	* @return the place of this activity
	*/
	public java.lang.String getPlace() {
		return _activity.getPlace();
	}

	/**
	* Sets the place of this activity.
	*
	* @param place the place of this activity
	*/
	public void setPlace(java.lang.String place) {
		_activity.setPlace(place);
	}

	/**
	* Returns the objective of this activity.
	*
	* @return the objective of this activity
	*/
	public java.lang.String getObjective() {
		return _activity.getObjective();
	}

	/**
	* Sets the objective of this activity.
	*
	* @param objective the objective of this activity
	*/
	public void setObjective(java.lang.String objective) {
		_activity.setObjective(objective);
	}

	/**
	* Returns the equipment to buy of this activity.
	*
	* @return the equipment to buy of this activity
	*/
	public java.lang.String getEquipmentToBuy() {
		return _activity.getEquipmentToBuy();
	}

	/**
	* Sets the equipment to buy of this activity.
	*
	* @param equipmentToBuy the equipment to buy of this activity
	*/
	public void setEquipmentToBuy(java.lang.String equipmentToBuy) {
		_activity.setEquipmentToBuy(equipmentToBuy);
	}

	/**
	* Returns the budget of this activity.
	*
	* @return the budget of this activity
	*/
	public java.lang.Float getBudget() {
		return _activity.getBudget();
	}

	/**
	* Sets the budget of this activity.
	*
	* @param budget the budget of this activity
	*/
	public void setBudget(java.lang.Float budget) {
		_activity.setBudget(budget);
	}

	/**
	* Returns the description of this activity.
	*
	* @return the description of this activity
	*/
	public java.lang.String getDescription() {
		return _activity.getDescription();
	}

	/**
	* Sets the description of this activity.
	*
	* @param description the description of this activity
	*/
	public void setDescription(java.lang.String description) {
		_activity.setDescription(description);
	}

	/**
	* Returns the personal of this activity.
	*
	* @return the personal of this activity
	*/
	public java.lang.String getPersonal() {
		return _activity.getPersonal();
	}

	/**
	* Sets the personal of this activity.
	*
	* @param personal the personal of this activity
	*/
	public void setPersonal(java.lang.String personal) {
		_activity.setPersonal(personal);
	}

	/**
	* Returns the material of this activity.
	*
	* @return the material of this activity
	*/
	public java.lang.String getMaterial() {
		return _activity.getMaterial();
	}

	/**
	* Sets the material of this activity.
	*
	* @param material the material of this activity
	*/
	public void setMaterial(java.lang.String material) {
		_activity.setMaterial(material);
	}

	/**
	* Returns the observation of this activity.
	*
	* @return the observation of this activity
	*/
	public java.lang.String getObservation() {
		return _activity.getObservation();
	}

	/**
	* Sets the observation of this activity.
	*
	* @param observation the observation of this activity
	*/
	public void setObservation(java.lang.String observation) {
		_activity.setObservation(observation);
	}

	/**
	* Returns the company ID of this activity.
	*
	* @return the company ID of this activity
	*/
	public long getCompanyId() {
		return _activity.getCompanyId();
	}

	/**
	* Sets the company ID of this activity.
	*
	* @param companyId the company ID of this activity
	*/
	public void setCompanyId(long companyId) {
		_activity.setCompanyId(companyId);
	}

	/**
	* Returns the group ID of this activity.
	*
	* @return the group ID of this activity
	*/
	public long getGroupId() {
		return _activity.getGroupId();
	}

	/**
	* Sets the group ID of this activity.
	*
	* @param groupId the group ID of this activity
	*/
	public void setGroupId(long groupId) {
		_activity.setGroupId(groupId);
	}

	/**
	* Returns the user ID of this activity.
	*
	* @return the user ID of this activity
	*/
	public long getUserId() {
		return _activity.getUserId();
	}

	/**
	* Sets the user ID of this activity.
	*
	* @param userId the user ID of this activity
	*/
	public void setUserId(long userId) {
		_activity.setUserId(userId);
	}

	/**
	* Returns the user uuid of this activity.
	*
	* @return the user uuid of this activity
	* @throws SystemException if a system exception occurred
	*/
	public java.lang.String getUserUuid()
		throws com.liferay.portal.kernel.exception.SystemException {
		return _activity.getUserUuid();
	}

	/**
	* Sets the user uuid of this activity.
	*
	* @param userUuid the user uuid of this activity
	*/
	public void setUserUuid(java.lang.String userUuid) {
		_activity.setUserUuid(userUuid);
	}

	public boolean isNew() {
		return _activity.isNew();
	}

	public void setNew(boolean n) {
		_activity.setNew(n);
	}

	public boolean isCachedModel() {
		return _activity.isCachedModel();
	}

	public void setCachedModel(boolean cachedModel) {
		_activity.setCachedModel(cachedModel);
	}

	public boolean isEscapedModel() {
		return _activity.isEscapedModel();
	}

	public java.io.Serializable getPrimaryKeyObj() {
		return _activity.getPrimaryKeyObj();
	}

	public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
		_activity.setPrimaryKeyObj(primaryKeyObj);
	}

	public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
		return _activity.getExpandoBridge();
	}

	public void setExpandoBridgeAttributes(
		com.liferay.portal.service.ServiceContext serviceContext) {
		_activity.setExpandoBridgeAttributes(serviceContext);
	}

	@Override
	public java.lang.Object clone() {
		return new ActivityWrapper((Activity)_activity.clone());
	}

	public int compareTo(com.martico.model.Activity activity) {
		return _activity.compareTo(activity);
	}

	@Override
	public int hashCode() {
		return _activity.hashCode();
	}

	public com.liferay.portal.model.CacheModel<com.martico.model.Activity> toCacheModel() {
		return _activity.toCacheModel();
	}

	public com.martico.model.Activity toEscapedModel() {
		return new ActivityWrapper(_activity.toEscapedModel());
	}

	@Override
	public java.lang.String toString() {
		return _activity.toString();
	}

	public java.lang.String toXmlString() {
		return _activity.toXmlString();
	}

	public void persist()
		throws com.liferay.portal.kernel.exception.SystemException {
		_activity.persist();
	}

	/**
	 * @deprecated Renamed to {@link #getWrappedModel}
	 */
	public Activity getWrappedActivity() {
		return _activity;
	}

	public Activity getWrappedModel() {
		return _activity;
	}

	public void resetOriginalValues() {
		_activity.resetOriginalValues();
	}

	private Activity _activity;
}