/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.InvokableLocalService;

/**
 * The utility for the activity objective local service. This utility wraps {@link com.martico.service.impl.ActivityObjectiveLocalServiceImpl} and is the primary access point for service operations in application layer code running on the local server.
 *
 * <p>
 * This is a local service. Methods of this service will not have security checks based on the propagated JAAS credentials because this service can only be accessed from within the same VM.
 * </p>
 *
 * @author edusaldana
 * @see ActivityObjectiveLocalService
 * @see com.martico.service.base.ActivityObjectiveLocalServiceBaseImpl
 * @see com.martico.service.impl.ActivityObjectiveLocalServiceImpl
 * @generated
 */
public class ActivityObjectiveLocalServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link com.martico.service.impl.ActivityObjectiveLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	* Adds the activity objective to the database. Also notifies the appropriate model listeners.
	*
	* @param activityObjective the activity objective
	* @return the activity objective that was added
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective addActivityObjective(
		com.martico.model.ActivityObjective activityObjective)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().addActivityObjective(activityObjective);
	}

	/**
	* Creates a new activity objective with the primary key. Does not add the activity objective to the database.
	*
	* @param activityObjectiveId the primary key for the new activity objective
	* @return the new activity objective
	*/
	public static com.martico.model.ActivityObjective createActivityObjective(
		long activityObjectiveId) {
		return getService().createActivityObjective(activityObjectiveId);
	}

	/**
	* Deletes the activity objective with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param activityObjectiveId the primary key of the activity objective
	* @return the activity objective that was removed
	* @throws PortalException if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective deleteActivityObjective(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService().deleteActivityObjective(activityObjectiveId);
	}

	/**
	* Deletes the activity objective from the database. Also notifies the appropriate model listeners.
	*
	* @param activityObjective the activity objective
	* @return the activity objective that was removed
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective deleteActivityObjective(
		com.martico.model.ActivityObjective activityObjective)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().deleteActivityObjective(activityObjective);
	}

	public static com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return getService().dynamicQuery();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQueryCount(dynamicQuery);
	}

	public static com.martico.model.ActivityObjective fetchActivityObjective(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().fetchActivityObjective(activityObjectiveId);
	}

	/**
	* Returns the activity objective with the primary key.
	*
	* @param activityObjectiveId the primary key of the activity objective
	* @return the activity objective
	* @throws PortalException if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective getActivityObjective(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService().getActivityObjective(activityObjectiveId);
	}

	public static com.liferay.portal.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService().getPersistedModel(primaryKeyObj);
	}

	/**
	* Returns a range of all the activity objectives.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of activity objectives
	* @param end the upper bound of the range of activity objectives (not inclusive)
	* @return the range of activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> getActivityObjectives(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getActivityObjectives(start, end);
	}

	/**
	* Returns the number of activity objectives.
	*
	* @return the number of activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static int getActivityObjectivesCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getActivityObjectivesCount();
	}

	/**
	* Updates the activity objective in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param activityObjective the activity objective
	* @return the activity objective that was updated
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective updateActivityObjective(
		com.martico.model.ActivityObjective activityObjective)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().updateActivityObjective(activityObjective);
	}

	/**
	* Updates the activity objective in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param activityObjective the activity objective
	* @param merge whether to merge the activity objective with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	* @return the activity objective that was updated
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective updateActivityObjective(
		com.martico.model.ActivityObjective activityObjective, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().updateActivityObjective(activityObjective, merge);
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	public static java.lang.String getBeanIdentifier() {
		return getService().getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	public static void setBeanIdentifier(java.lang.String beanIdentifier) {
		getService().setBeanIdentifier(beanIdentifier);
	}

	public static java.lang.Object invokeMethod(java.lang.String name,
		java.lang.String[] parameterTypes, java.lang.Object[] arguments)
		throws java.lang.Throwable {
		return getService().invokeMethod(name, parameterTypes, arguments);
	}

	public static void clearService() {
		_service = null;
	}

	public static ActivityObjectiveLocalService getService() {
		if (_service == null) {
			InvokableLocalService invokableLocalService = (InvokableLocalService)PortletBeanLocatorUtil.locate(ClpSerializer.getServletContextName(),
					ActivityObjectiveLocalService.class.getName());

			if (invokableLocalService instanceof ActivityObjectiveLocalService) {
				_service = (ActivityObjectiveLocalService)invokableLocalService;
			}
			else {
				_service = new ActivityObjectiveLocalServiceClp(invokableLocalService);
			}

			ReferenceRegistry.registerReference(ActivityObjectiveLocalServiceUtil.class,
				"_service");
		}

		return _service;
	}

	/**
	 * @deprecated
	 */
	public void setService(ActivityObjectiveLocalService service) {
	}

	private static ActivityObjectiveLocalService _service;
}