/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.ServiceContext;

import com.martico.model.ActivityObjective;

import java.util.List;

/**
 * The persistence utility for the activity objective service. This utility wraps {@link ActivityObjectivePersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author edusaldana
 * @see ActivityObjectivePersistence
 * @see ActivityObjectivePersistenceImpl
 * @generated
 */
public class ActivityObjectiveUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache()
	 */
	public static void clearCache() {
		getPersistence().clearCache();
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#clearCache(com.liferay.portal.model.BaseModel)
	 */
	public static void clearCache(ActivityObjective activityObjective) {
		getPersistence().clearCache(activityObjective);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
	 */
	public long countWithDynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return getPersistence().countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
	 */
	public static List<ActivityObjective> findWithDynamicQuery(
		DynamicQuery dynamicQuery) throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
	 */
	public static List<ActivityObjective> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
	 */
	public static List<ActivityObjective> findWithDynamicQuery(
		DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return getPersistence()
				   .findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean)
	 */
	public static ActivityObjective update(
		ActivityObjective activityObjective, boolean merge)
		throws SystemException {
		return getPersistence().update(activityObjective, merge);
	}

	/**
	 * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, boolean, ServiceContext)
	 */
	public static ActivityObjective update(
		ActivityObjective activityObjective, boolean merge,
		ServiceContext serviceContext) throws SystemException {
		return getPersistence().update(activityObjective, merge, serviceContext);
	}

	/**
	* Caches the activity objective in the entity cache if it is enabled.
	*
	* @param activityObjective the activity objective
	*/
	public static void cacheResult(
		com.martico.model.ActivityObjective activityObjective) {
		getPersistence().cacheResult(activityObjective);
	}

	/**
	* Caches the activity objectives in the entity cache if it is enabled.
	*
	* @param activityObjectives the activity objectives
	*/
	public static void cacheResult(
		java.util.List<com.martico.model.ActivityObjective> activityObjectives) {
		getPersistence().cacheResult(activityObjectives);
	}

	/**
	* Creates a new activity objective with the primary key. Does not add the activity objective to the database.
	*
	* @param activityObjectiveId the primary key for the new activity objective
	* @return the new activity objective
	*/
	public static com.martico.model.ActivityObjective create(
		long activityObjectiveId) {
		return getPersistence().create(activityObjectiveId);
	}

	/**
	* Removes the activity objective with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param activityObjectiveId the primary key of the activity objective
	* @return the activity objective that was removed
	* @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective remove(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.martico.NoSuchActivityObjectiveException {
		return getPersistence().remove(activityObjectiveId);
	}

	public static com.martico.model.ActivityObjective updateImpl(
		com.martico.model.ActivityObjective activityObjective, boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().updateImpl(activityObjective, merge);
	}

	/**
	* Returns the activity objective with the primary key or throws a {@link com.martico.NoSuchActivityObjectiveException} if it could not be found.
	*
	* @param activityObjectiveId the primary key of the activity objective
	* @return the activity objective
	* @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective findByPrimaryKey(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.martico.NoSuchActivityObjectiveException {
		return getPersistence().findByPrimaryKey(activityObjectiveId);
	}

	/**
	* Returns the activity objective with the primary key or returns <code>null</code> if it could not be found.
	*
	* @param activityObjectiveId the primary key of the activity objective
	* @return the activity objective, or <code>null</code> if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective fetchByPrimaryKey(
		long activityObjectiveId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().fetchByPrimaryKey(activityObjectiveId);
	}

	/**
	* Returns all the activity objectives where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @return the matching activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findByActivity(
		long activityId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByActivity(activityId);
	}

	/**
	* Returns a range of all the activity objectives where activityId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param activityId the activity ID
	* @param start the lower bound of the range of activity objectives
	* @param end the upper bound of the range of activity objectives (not inclusive)
	* @return the range of matching activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findByActivity(
		long activityId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findByActivity(activityId, start, end);
	}

	/**
	* Returns an ordered range of all the activity objectives where activityId = &#63;.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param activityId the activity ID
	* @param start the lower bound of the range of activity objectives
	* @param end the upper bound of the range of activity objectives (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findByActivity(
		long activityId, int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .findByActivity(activityId, start, end, orderByComparator);
	}

	/**
	* Returns the first activity objective in the ordered set where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching activity objective
	* @throws com.martico.NoSuchActivityObjectiveException if a matching activity objective could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective findByActivity_First(
		long activityId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.martico.NoSuchActivityObjectiveException {
		return getPersistence()
				   .findByActivity_First(activityId, orderByComparator);
	}

	/**
	* Returns the first activity objective in the ordered set where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the first matching activity objective, or <code>null</code> if a matching activity objective could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective fetchByActivity_First(
		long activityId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByActivity_First(activityId, orderByComparator);
	}

	/**
	* Returns the last activity objective in the ordered set where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching activity objective
	* @throws com.martico.NoSuchActivityObjectiveException if a matching activity objective could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective findByActivity_Last(
		long activityId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.martico.NoSuchActivityObjectiveException {
		return getPersistence()
				   .findByActivity_Last(activityId, orderByComparator);
	}

	/**
	* Returns the last activity objective in the ordered set where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the last matching activity objective, or <code>null</code> if a matching activity objective could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective fetchByActivity_Last(
		long activityId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence()
				   .fetchByActivity_Last(activityId, orderByComparator);
	}

	/**
	* Returns the activity objectives before and after the current activity objective in the ordered set where activityId = &#63;.
	*
	* @param activityObjectiveId the primary key of the current activity objective
	* @param activityId the activity ID
	* @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	* @return the previous, current, and next activity objective
	* @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static com.martico.model.ActivityObjective[] findByActivity_PrevAndNext(
		long activityObjectiveId, long activityId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException,
			com.martico.NoSuchActivityObjectiveException {
		return getPersistence()
				   .findByActivity_PrevAndNext(activityObjectiveId, activityId,
			orderByComparator);
	}

	/**
	* Returns all the activity objectives.
	*
	* @return the activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll();
	}

	/**
	* Returns a range of all the activity objectives.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of activity objectives
	* @param end the upper bound of the range of activity objectives (not inclusive)
	* @return the range of activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findAll(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end);
	}

	/**
	* Returns an ordered range of all the activity objectives.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of activity objectives
	* @param end the upper bound of the range of activity objectives (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<com.martico.model.ActivityObjective> findAll(
		int start, int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().findAll(start, end, orderByComparator);
	}

	/**
	* Removes all the activity objectives where activityId = &#63; from the database.
	*
	* @param activityId the activity ID
	* @throws SystemException if a system exception occurred
	*/
	public static void removeByActivity(long activityId)
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeByActivity(activityId);
	}

	/**
	* Removes all the activity objectives from the database.
	*
	* @throws SystemException if a system exception occurred
	*/
	public static void removeAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		getPersistence().removeAll();
	}

	/**
	* Returns the number of activity objectives where activityId = &#63;.
	*
	* @param activityId the activity ID
	* @return the number of matching activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static int countByActivity(long activityId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countByActivity(activityId);
	}

	/**
	* Returns the number of activity objectives.
	*
	* @return the number of activity objectives
	* @throws SystemException if a system exception occurred
	*/
	public static int countAll()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getPersistence().countAll();
	}

	public static ActivityObjectivePersistence getPersistence() {
		if (_persistence == null) {
			_persistence = (ActivityObjectivePersistence)PortletBeanLocatorUtil.locate(com.martico.service.ClpSerializer.getServletContextName(),
					ActivityObjectivePersistence.class.getName());

			ReferenceRegistry.registerReference(ActivityObjectiveUtil.class,
				"_persistence");
		}

		return _persistence;
	}

	/**
	 * @deprecated
	 */
	public void setPersistence(ActivityObjectivePersistence persistence) {
	}

	private static ActivityObjectivePersistence _persistence;
}