/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.martico.model.Activity;

import java.io.Serializable;

import java.util.Date;

/**
 * The cache model class for representing Activity in entity cache.
 *
 * @author edusaldana
 * @see Activity
 * @generated
 */
public class ActivityCacheModel implements CacheModel<Activity>, Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(37);

		sb.append("{activityId=");
		sb.append(activityId);
		sb.append(", name=");
		sb.append(name);
		sb.append(", responsible=");
		sb.append(responsible);
		sb.append(", date=");
		sb.append(date);
		sb.append(", duration=");
		sb.append(duration);
		sb.append(", recipient=");
		sb.append(recipient);
		sb.append(", ages=");
		sb.append(ages);
		sb.append(", place=");
		sb.append(place);
		sb.append(", objective=");
		sb.append(objective);
		sb.append(", equipmentToBuy=");
		sb.append(equipmentToBuy);
		sb.append(", budget=");
		sb.append(budget);
		sb.append(", description=");
		sb.append(description);
		sb.append(", personal=");
		sb.append(personal);
		sb.append(", material=");
		sb.append(material);
		sb.append(", observation=");
		sb.append(observation);
		sb.append(", companyId=");
		sb.append(companyId);
		sb.append(", groupId=");
		sb.append(groupId);
		sb.append(", userId=");
		sb.append(userId);
		sb.append("}");

		return sb.toString();
	}

	public Activity toEntityModel() {
		ActivityImpl activityImpl = new ActivityImpl();

		activityImpl.setActivityId(activityId);

		if (name == null) {
			activityImpl.setName(StringPool.BLANK);
		}
		else {
			activityImpl.setName(name);
		}

		if (responsible == null) {
			activityImpl.setResponsible(StringPool.BLANK);
		}
		else {
			activityImpl.setResponsible(responsible);
		}

		if (date == Long.MIN_VALUE) {
			activityImpl.setDate(null);
		}
		else {
			activityImpl.setDate(new Date(date));
		}

		activityImpl.setDuration(duration);
		activityImpl.setRecipient(recipient);

		if (ages == null) {
			activityImpl.setAges(StringPool.BLANK);
		}
		else {
			activityImpl.setAges(ages);
		}

		if (place == null) {
			activityImpl.setPlace(StringPool.BLANK);
		}
		else {
			activityImpl.setPlace(place);
		}

		if (objective == null) {
			activityImpl.setObjective(StringPool.BLANK);
		}
		else {
			activityImpl.setObjective(objective);
		}

		if (equipmentToBuy == null) {
			activityImpl.setEquipmentToBuy(StringPool.BLANK);
		}
		else {
			activityImpl.setEquipmentToBuy(equipmentToBuy);
		}

		activityImpl.setBudget(budget);

		if (description == null) {
			activityImpl.setDescription(StringPool.BLANK);
		}
		else {
			activityImpl.setDescription(description);
		}

		if (personal == null) {
			activityImpl.setPersonal(StringPool.BLANK);
		}
		else {
			activityImpl.setPersonal(personal);
		}

		if (material == null) {
			activityImpl.setMaterial(StringPool.BLANK);
		}
		else {
			activityImpl.setMaterial(material);
		}

		if (observation == null) {
			activityImpl.setObservation(StringPool.BLANK);
		}
		else {
			activityImpl.setObservation(observation);
		}

		activityImpl.setCompanyId(companyId);
		activityImpl.setGroupId(groupId);
		activityImpl.setUserId(userId);

		activityImpl.resetOriginalValues();

		return activityImpl;
	}

	public long activityId;
	public String name;
	public String responsible;
	public long date;
	public Integer duration;
	public Integer recipient;
	public String ages;
	public String place;
	public String objective;
	public String equipmentToBuy;
	public Float budget;
	public String description;
	public String personal;
	public String material;
	public String observation;
	public long companyId;
	public long groupId;
	public long userId;
}