/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import com.martico.model.Activity;
import com.martico.model.ActivityModel;
import com.martico.model.ActivitySoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Activity service. Represents a row in the &quot;martico_Activity&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.martico.model.ActivityModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link ActivityImpl}.
 * </p>
 *
 * @author edusaldana
 * @see ActivityImpl
 * @see com.martico.model.Activity
 * @see com.martico.model.ActivityModel
 * @generated
 */
@JSON(strict = true)
public class ActivityModelImpl extends BaseModelImpl<Activity>
	implements ActivityModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a activity model instance should use the {@link com.martico.model.Activity} interface instead.
	 */
	public static final String TABLE_NAME = "martico_Activity";
	public static final Object[][] TABLE_COLUMNS = {
			{ "activityId", Types.BIGINT },
			{ "name", Types.VARCHAR },
			{ "responsible", Types.VARCHAR },
			{ "date_", Types.TIMESTAMP },
			{ "duration", Types.INTEGER },
			{ "recipient", Types.INTEGER },
			{ "ages", Types.VARCHAR },
			{ "place", Types.VARCHAR },
			{ "objective", Types.VARCHAR },
			{ "equipmentToBuy", Types.VARCHAR },
			{ "budget", Types.FLOAT },
			{ "description", Types.VARCHAR },
			{ "personal", Types.VARCHAR },
			{ "material", Types.VARCHAR },
			{ "observation", Types.VARCHAR },
			{ "companyId", Types.BIGINT },
			{ "groupId", Types.BIGINT },
			{ "userId", Types.BIGINT }
		};
	public static final String TABLE_SQL_CREATE = "create table martico_Activity (activityId LONG not null primary key,name VARCHAR(300) null,responsible VARCHAR(300) null,date_ DATE null,duration INTEGER,recipient INTEGER,ages VARCHAR(75) null,place VARCHAR(75) null,objective TEXT null,equipmentToBuy TEXT null,budget DOUBLE,description TEXT null,personal TEXT null,material TEXT null,observation TEXT null,companyId LONG,groupId LONG,userId LONG)";
	public static final String TABLE_SQL_DROP = "drop table martico_Activity";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.martico.model.Activity"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.martico.model.Activity"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.com.martico.model.Activity"),
			true);
	public static long COMPANYID_COLUMN_BITMASK = 1L;
	public static long GROUPID_COLUMN_BITMASK = 2L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static Activity toModel(ActivitySoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		Activity model = new ActivityImpl();

		model.setActivityId(soapModel.getActivityId());
		model.setName(soapModel.getName());
		model.setResponsible(soapModel.getResponsible());
		model.setDate(soapModel.getDate());
		model.setDuration(soapModel.getDuration());
		model.setRecipient(soapModel.getRecipient());
		model.setAges(soapModel.getAges());
		model.setPlace(soapModel.getPlace());
		model.setObjective(soapModel.getObjective());
		model.setEquipmentToBuy(soapModel.getEquipmentToBuy());
		model.setBudget(soapModel.getBudget());
		model.setDescription(soapModel.getDescription());
		model.setPersonal(soapModel.getPersonal());
		model.setMaterial(soapModel.getMaterial());
		model.setObservation(soapModel.getObservation());
		model.setCompanyId(soapModel.getCompanyId());
		model.setGroupId(soapModel.getGroupId());
		model.setUserId(soapModel.getUserId());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<Activity> toModels(ActivitySoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<Activity> models = new ArrayList<Activity>(soapModels.length);

		for (ActivitySoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.martico.model.Activity"));

	public ActivityModelImpl() {
	}

	public long getPrimaryKey() {
		return _activityId;
	}

	public void setPrimaryKey(long primaryKey) {
		setActivityId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_activityId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	public Class<?> getModelClass() {
		return Activity.class;
	}

	public String getModelClassName() {
		return Activity.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityId", getActivityId());
		attributes.put("name", getName());
		attributes.put("responsible", getResponsible());
		attributes.put("date", getDate());
		attributes.put("duration", getDuration());
		attributes.put("recipient", getRecipient());
		attributes.put("ages", getAges());
		attributes.put("place", getPlace());
		attributes.put("objective", getObjective());
		attributes.put("equipmentToBuy", getEquipmentToBuy());
		attributes.put("budget", getBudget());
		attributes.put("description", getDescription());
		attributes.put("personal", getPersonal());
		attributes.put("material", getMaterial());
		attributes.put("observation", getObservation());
		attributes.put("companyId", getCompanyId());
		attributes.put("groupId", getGroupId());
		attributes.put("userId", getUserId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String responsible = (String)attributes.get("responsible");

		if (responsible != null) {
			setResponsible(responsible);
		}

		Date date = (Date)attributes.get("date");

		if (date != null) {
			setDate(date);
		}

		Integer duration = (Integer)attributes.get("duration");

		if (duration != null) {
			setDuration(duration);
		}

		Integer recipient = (Integer)attributes.get("recipient");

		if (recipient != null) {
			setRecipient(recipient);
		}

		String ages = (String)attributes.get("ages");

		if (ages != null) {
			setAges(ages);
		}

		String place = (String)attributes.get("place");

		if (place != null) {
			setPlace(place);
		}

		String objective = (String)attributes.get("objective");

		if (objective != null) {
			setObjective(objective);
		}

		String equipmentToBuy = (String)attributes.get("equipmentToBuy");

		if (equipmentToBuy != null) {
			setEquipmentToBuy(equipmentToBuy);
		}

		Float budget = (Float)attributes.get("budget");

		if (budget != null) {
			setBudget(budget);
		}

		String description = (String)attributes.get("description");

		if (description != null) {
			setDescription(description);
		}

		String personal = (String)attributes.get("personal");

		if (personal != null) {
			setPersonal(personal);
		}

		String material = (String)attributes.get("material");

		if (material != null) {
			setMaterial(material);
		}

		String observation = (String)attributes.get("observation");

		if (observation != null) {
			setObservation(observation);
		}

		Long companyId = (Long)attributes.get("companyId");

		if (companyId != null) {
			setCompanyId(companyId);
		}

		Long groupId = (Long)attributes.get("groupId");

		if (groupId != null) {
			setGroupId(groupId);
		}

		Long userId = (Long)attributes.get("userId");

		if (userId != null) {
			setUserId(userId);
		}
	}

	@JSON
	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_activityId = activityId;
	}

	@JSON
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	public void setName(String name) {
		_name = name;
	}

	@JSON
	public String getResponsible() {
		if (_responsible == null) {
			return StringPool.BLANK;
		}
		else {
			return _responsible;
		}
	}

	public void setResponsible(String responsible) {
		_responsible = responsible;
	}

	@JSON
	public Date getDate() {
		return _date;
	}

	public void setDate(Date date) {
		_date = date;
	}

	@JSON
	public Integer getDuration() {
		return _duration;
	}

	public void setDuration(Integer duration) {
		_duration = duration;
	}

	@JSON
	public Integer getRecipient() {
		return _recipient;
	}

	public void setRecipient(Integer recipient) {
		_recipient = recipient;
	}

	@JSON
	public String getAges() {
		if (_ages == null) {
			return StringPool.BLANK;
		}
		else {
			return _ages;
		}
	}

	public void setAges(String ages) {
		_ages = ages;
	}

	@JSON
	public String getPlace() {
		if (_place == null) {
			return StringPool.BLANK;
		}
		else {
			return _place;
		}
	}

	public void setPlace(String place) {
		_place = place;
	}

	@JSON
	public String getObjective() {
		if (_objective == null) {
			return StringPool.BLANK;
		}
		else {
			return _objective;
		}
	}

	public void setObjective(String objective) {
		_objective = objective;
	}

	@JSON
	public String getEquipmentToBuy() {
		if (_equipmentToBuy == null) {
			return StringPool.BLANK;
		}
		else {
			return _equipmentToBuy;
		}
	}

	public void setEquipmentToBuy(String equipmentToBuy) {
		_equipmentToBuy = equipmentToBuy;
	}

	@JSON
	public Float getBudget() {
		return _budget;
	}

	public void setBudget(Float budget) {
		_budget = budget;
	}

	@JSON
	public String getDescription() {
		if (_description == null) {
			return StringPool.BLANK;
		}
		else {
			return _description;
		}
	}

	public void setDescription(String description) {
		_description = description;
	}

	@JSON
	public String getPersonal() {
		if (_personal == null) {
			return StringPool.BLANK;
		}
		else {
			return _personal;
		}
	}

	public void setPersonal(String personal) {
		_personal = personal;
	}

	@JSON
	public String getMaterial() {
		if (_material == null) {
			return StringPool.BLANK;
		}
		else {
			return _material;
		}
	}

	public void setMaterial(String material) {
		_material = material;
	}

	@JSON
	public String getObservation() {
		if (_observation == null) {
			return StringPool.BLANK;
		}
		else {
			return _observation;
		}
	}

	public void setObservation(String observation) {
		_observation = observation;
	}

	@JSON
	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_columnBitmask |= COMPANYID_COLUMN_BITMASK;

		if (!_setOriginalCompanyId) {
			_setOriginalCompanyId = true;

			_originalCompanyId = _companyId;
		}

		_companyId = companyId;
	}

	public long getOriginalCompanyId() {
		return _originalCompanyId;
	}

	@JSON
	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_columnBitmask |= GROUPID_COLUMN_BITMASK;

		if (!_setOriginalGroupId) {
			_setOriginalGroupId = true;

			_originalGroupId = _groupId;
		}

		_groupId = groupId;
	}

	public long getOriginalGroupId() {
		return _originalGroupId;
	}

	@JSON
	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
			Activity.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public Activity toEscapedModel() {
		if (_escapedModelProxy == null) {
			_escapedModelProxy = (Activity)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelProxyInterfaces,
					new AutoEscapeBeanHandler(this));
		}

		return _escapedModelProxy;
	}

	@Override
	public Object clone() {
		ActivityImpl activityImpl = new ActivityImpl();

		activityImpl.setActivityId(getActivityId());
		activityImpl.setName(getName());
		activityImpl.setResponsible(getResponsible());
		activityImpl.setDate(getDate());
		activityImpl.setDuration(getDuration());
		activityImpl.setRecipient(getRecipient());
		activityImpl.setAges(getAges());
		activityImpl.setPlace(getPlace());
		activityImpl.setObjective(getObjective());
		activityImpl.setEquipmentToBuy(getEquipmentToBuy());
		activityImpl.setBudget(getBudget());
		activityImpl.setDescription(getDescription());
		activityImpl.setPersonal(getPersonal());
		activityImpl.setMaterial(getMaterial());
		activityImpl.setObservation(getObservation());
		activityImpl.setCompanyId(getCompanyId());
		activityImpl.setGroupId(getGroupId());
		activityImpl.setUserId(getUserId());

		activityImpl.resetOriginalValues();

		return activityImpl;
	}

	public int compareTo(Activity activity) {
		long primaryKey = activity.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		Activity activity = null;

		try {
			activity = (Activity)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = activity.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		ActivityModelImpl activityModelImpl = this;

		activityModelImpl._originalCompanyId = activityModelImpl._companyId;

		activityModelImpl._setOriginalCompanyId = false;

		activityModelImpl._originalGroupId = activityModelImpl._groupId;

		activityModelImpl._setOriginalGroupId = false;

		activityModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Activity> toCacheModel() {
		ActivityCacheModel activityCacheModel = new ActivityCacheModel();

		activityCacheModel.activityId = getActivityId();

		activityCacheModel.name = getName();

		String name = activityCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			activityCacheModel.name = null;
		}

		activityCacheModel.responsible = getResponsible();

		String responsible = activityCacheModel.responsible;

		if ((responsible != null) && (responsible.length() == 0)) {
			activityCacheModel.responsible = null;
		}

		Date date = getDate();

		if (date != null) {
			activityCacheModel.date = date.getTime();
		}
		else {
			activityCacheModel.date = Long.MIN_VALUE;
		}

		activityCacheModel.duration = getDuration();

		activityCacheModel.recipient = getRecipient();

		activityCacheModel.ages = getAges();

		String ages = activityCacheModel.ages;

		if ((ages != null) && (ages.length() == 0)) {
			activityCacheModel.ages = null;
		}

		activityCacheModel.place = getPlace();

		String place = activityCacheModel.place;

		if ((place != null) && (place.length() == 0)) {
			activityCacheModel.place = null;
		}

		activityCacheModel.objective = getObjective();

		String objective = activityCacheModel.objective;

		if ((objective != null) && (objective.length() == 0)) {
			activityCacheModel.objective = null;
		}

		activityCacheModel.equipmentToBuy = getEquipmentToBuy();

		String equipmentToBuy = activityCacheModel.equipmentToBuy;

		if ((equipmentToBuy != null) && (equipmentToBuy.length() == 0)) {
			activityCacheModel.equipmentToBuy = null;
		}

		activityCacheModel.budget = getBudget();

		activityCacheModel.description = getDescription();

		String description = activityCacheModel.description;

		if ((description != null) && (description.length() == 0)) {
			activityCacheModel.description = null;
		}

		activityCacheModel.personal = getPersonal();

		String personal = activityCacheModel.personal;

		if ((personal != null) && (personal.length() == 0)) {
			activityCacheModel.personal = null;
		}

		activityCacheModel.material = getMaterial();

		String material = activityCacheModel.material;

		if ((material != null) && (material.length() == 0)) {
			activityCacheModel.material = null;
		}

		activityCacheModel.observation = getObservation();

		String observation = activityCacheModel.observation;

		if ((observation != null) && (observation.length() == 0)) {
			activityCacheModel.observation = null;
		}

		activityCacheModel.companyId = getCompanyId();

		activityCacheModel.groupId = getGroupId();

		activityCacheModel.userId = getUserId();

		return activityCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(37);

		sb.append("{activityId=");
		sb.append(getActivityId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", responsible=");
		sb.append(getResponsible());
		sb.append(", date=");
		sb.append(getDate());
		sb.append(", duration=");
		sb.append(getDuration());
		sb.append(", recipient=");
		sb.append(getRecipient());
		sb.append(", ages=");
		sb.append(getAges());
		sb.append(", place=");
		sb.append(getPlace());
		sb.append(", objective=");
		sb.append(getObjective());
		sb.append(", equipmentToBuy=");
		sb.append(getEquipmentToBuy());
		sb.append(", budget=");
		sb.append(getBudget());
		sb.append(", description=");
		sb.append(getDescription());
		sb.append(", personal=");
		sb.append(getPersonal());
		sb.append(", material=");
		sb.append(getMaterial());
		sb.append(", observation=");
		sb.append(getObservation());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(58);

		sb.append("<model><model-name>");
		sb.append("com.martico.model.Activity");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>activityId</column-name><column-value><![CDATA[");
		sb.append(getActivityId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>responsible</column-name><column-value><![CDATA[");
		sb.append(getResponsible());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>date</column-name><column-value><![CDATA[");
		sb.append(getDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>duration</column-name><column-value><![CDATA[");
		sb.append(getDuration());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>recipient</column-name><column-value><![CDATA[");
		sb.append(getRecipient());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ages</column-name><column-value><![CDATA[");
		sb.append(getAges());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>place</column-name><column-value><![CDATA[");
		sb.append(getPlace());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>objective</column-name><column-value><![CDATA[");
		sb.append(getObjective());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>equipmentToBuy</column-name><column-value><![CDATA[");
		sb.append(getEquipmentToBuy());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>budget</column-name><column-value><![CDATA[");
		sb.append(getBudget());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>description</column-name><column-value><![CDATA[");
		sb.append(getDescription());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>personal</column-name><column-value><![CDATA[");
		sb.append(getPersonal());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>material</column-name><column-value><![CDATA[");
		sb.append(getMaterial());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>observation</column-name><column-value><![CDATA[");
		sb.append(getObservation());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = Activity.class.getClassLoader();
	private static Class<?>[] _escapedModelProxyInterfaces = new Class[] {
			Activity.class
		};
	private long _activityId;
	private String _name;
	private String _responsible;
	private Date _date;
	private Integer _duration;
	private Integer _recipient;
	private String _ages;
	private String _place;
	private String _objective;
	private String _equipmentToBuy;
	private Float _budget;
	private String _description;
	private String _personal;
	private String _material;
	private String _observation;
	private long _companyId;
	private long _originalCompanyId;
	private boolean _setOriginalCompanyId;
	private long _groupId;
	private long _originalGroupId;
	private boolean _setOriginalGroupId;
	private long _userId;
	private String _userUuid;
	private long _columnBitmask;
	private Activity _escapedModelProxy;
}