/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.martico.model.ActivityObjective;

import java.io.Serializable;

/**
 * The cache model class for representing ActivityObjective in entity cache.
 *
 * @author edusaldana
 * @see ActivityObjective
 * @generated
 */
public class ActivityObjectiveCacheModel implements CacheModel<ActivityObjective>,
	Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(7);

		sb.append("{activityObjectiveId=");
		sb.append(activityObjectiveId);
		sb.append(", name=");
		sb.append(name);
		sb.append(", activityId=");
		sb.append(activityId);
		sb.append("}");

		return sb.toString();
	}

	public ActivityObjective toEntityModel() {
		ActivityObjectiveImpl activityObjectiveImpl = new ActivityObjectiveImpl();

		activityObjectiveImpl.setActivityObjectiveId(activityObjectiveId);

		if (name == null) {
			activityObjectiveImpl.setName(StringPool.BLANK);
		}
		else {
			activityObjectiveImpl.setName(name);
		}

		activityObjectiveImpl.setActivityId(activityId);

		activityObjectiveImpl.resetOriginalValues();

		return activityObjectiveImpl;
	}

	public long activityObjectiveId;
	public String name;
	public long activityId;
}