/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import com.martico.model.ActivityObjective;
import com.martico.model.ActivityObjectiveModel;
import com.martico.model.ActivityObjectiveSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the ActivityObjective service. Represents a row in the &quot;martico_ActivityObjective&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.martico.model.ActivityObjectiveModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link ActivityObjectiveImpl}.
 * </p>
 *
 * @author edusaldana
 * @see ActivityObjectiveImpl
 * @see com.martico.model.ActivityObjective
 * @see com.martico.model.ActivityObjectiveModel
 * @generated
 */
@JSON(strict = true)
public class ActivityObjectiveModelImpl extends BaseModelImpl<ActivityObjective>
	implements ActivityObjectiveModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a activity objective model instance should use the {@link com.martico.model.ActivityObjective} interface instead.
	 */
	public static final String TABLE_NAME = "martico_ActivityObjective";
	public static final Object[][] TABLE_COLUMNS = {
			{ "activityObjectiveId", Types.BIGINT },
			{ "name", Types.VARCHAR },
			{ "activityId", Types.BIGINT }
		};
	public static final String TABLE_SQL_CREATE = "create table martico_ActivityObjective (activityObjectiveId LONG not null primary key,name TEXT null,activityId LONG)";
	public static final String TABLE_SQL_DROP = "drop table martico_ActivityObjective";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.martico.model.ActivityObjective"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.martico.model.ActivityObjective"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.com.martico.model.ActivityObjective"),
			true);
	public static long ACTIVITYID_COLUMN_BITMASK = 1L;

	/**
	 * Converts the soap model instance into a normal model instance.
	 *
	 * @param soapModel the soap model instance to convert
	 * @return the normal model instance
	 */
	public static ActivityObjective toModel(ActivityObjectiveSoap soapModel) {
		if (soapModel == null) {
			return null;
		}

		ActivityObjective model = new ActivityObjectiveImpl();

		model.setActivityObjectiveId(soapModel.getActivityObjectiveId());
		model.setName(soapModel.getName());
		model.setActivityId(soapModel.getActivityId());

		return model;
	}

	/**
	 * Converts the soap model instances into normal model instances.
	 *
	 * @param soapModels the soap model instances to convert
	 * @return the normal model instances
	 */
	public static List<ActivityObjective> toModels(
		ActivityObjectiveSoap[] soapModels) {
		if (soapModels == null) {
			return null;
		}

		List<ActivityObjective> models = new ArrayList<ActivityObjective>(soapModels.length);

		for (ActivityObjectiveSoap soapModel : soapModels) {
			models.add(toModel(soapModel));
		}

		return models;
	}

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.martico.model.ActivityObjective"));

	public ActivityObjectiveModelImpl() {
	}

	public long getPrimaryKey() {
		return _activityObjectiveId;
	}

	public void setPrimaryKey(long primaryKey) {
		setActivityObjectiveId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_activityObjectiveId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	public Class<?> getModelClass() {
		return ActivityObjective.class;
	}

	public String getModelClassName() {
		return ActivityObjective.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("activityObjectiveId", getActivityObjectiveId());
		attributes.put("name", getName());
		attributes.put("activityId", getActivityId());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long activityObjectiveId = (Long)attributes.get("activityObjectiveId");

		if (activityObjectiveId != null) {
			setActivityObjectiveId(activityObjectiveId);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		Long activityId = (Long)attributes.get("activityId");

		if (activityId != null) {
			setActivityId(activityId);
		}
	}

	@JSON
	public long getActivityObjectiveId() {
		return _activityObjectiveId;
	}

	public void setActivityObjectiveId(long activityObjectiveId) {
		_activityObjectiveId = activityObjectiveId;
	}

	@JSON
	public String getName() {
		if (_name == null) {
			return StringPool.BLANK;
		}
		else {
			return _name;
		}
	}

	public void setName(String name) {
		_name = name;
	}

	@JSON
	public long getActivityId() {
		return _activityId;
	}

	public void setActivityId(long activityId) {
		_columnBitmask |= ACTIVITYID_COLUMN_BITMASK;

		if (!_setOriginalActivityId) {
			_setOriginalActivityId = true;

			_originalActivityId = _activityId;
		}

		_activityId = activityId;
	}

	public long getOriginalActivityId() {
		return _originalActivityId;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
			ActivityObjective.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public ActivityObjective toEscapedModel() {
		if (_escapedModelProxy == null) {
			_escapedModelProxy = (ActivityObjective)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelProxyInterfaces,
					new AutoEscapeBeanHandler(this));
		}

		return _escapedModelProxy;
	}

	@Override
	public Object clone() {
		ActivityObjectiveImpl activityObjectiveImpl = new ActivityObjectiveImpl();

		activityObjectiveImpl.setActivityObjectiveId(getActivityObjectiveId());
		activityObjectiveImpl.setName(getName());
		activityObjectiveImpl.setActivityId(getActivityId());

		activityObjectiveImpl.resetOriginalValues();

		return activityObjectiveImpl;
	}

	public int compareTo(ActivityObjective activityObjective) {
		long primaryKey = activityObjective.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		ActivityObjective activityObjective = null;

		try {
			activityObjective = (ActivityObjective)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = activityObjective.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		ActivityObjectiveModelImpl activityObjectiveModelImpl = this;

		activityObjectiveModelImpl._originalActivityId = activityObjectiveModelImpl._activityId;

		activityObjectiveModelImpl._setOriginalActivityId = false;

		activityObjectiveModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<ActivityObjective> toCacheModel() {
		ActivityObjectiveCacheModel activityObjectiveCacheModel = new ActivityObjectiveCacheModel();

		activityObjectiveCacheModel.activityObjectiveId = getActivityObjectiveId();

		activityObjectiveCacheModel.name = getName();

		String name = activityObjectiveCacheModel.name;

		if ((name != null) && (name.length() == 0)) {
			activityObjectiveCacheModel.name = null;
		}

		activityObjectiveCacheModel.activityId = getActivityId();

		return activityObjectiveCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(7);

		sb.append("{activityObjectiveId=");
		sb.append(getActivityObjectiveId());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", activityId=");
		sb.append(getActivityId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(13);

		sb.append("<model><model-name>");
		sb.append("com.martico.model.ActivityObjective");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>activityObjectiveId</column-name><column-value><![CDATA[");
		sb.append(getActivityObjectiveId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>activityId</column-name><column-value><![CDATA[");
		sb.append(getActivityId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = ActivityObjective.class.getClassLoader();
	private static Class<?>[] _escapedModelProxyInterfaces = new Class[] {
			ActivityObjective.class
		};
	private long _activityObjectiveId;
	private String _name;
	private long _activityId;
	private long _originalActivityId;
	private boolean _setOriginalActivityId;
	private long _columnBitmask;
	private ActivityObjective _escapedModelProxy;
}