package com.martico.portlet.activity;

import java.util.List;

import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.Validator;
import com.martico.model.Activity;
import com.martico.portlet.activity.form.ActivityForm;
import com.martico.portlet.util.DecimalFormatUtil;

public class ActivityValidator {
	public static boolean validate(Activity campaign, List<String> errors) {
		return true;
	}

	public static boolean validate(ActivityForm form, List<String> errors) throws SystemException {
		
		if (Validator.isNull(form.getName())) {
			errors.add("activity-name-required");
		}
		if (Validator.isNull(form.getResponsible())) {
			errors.add("activity-responsible-required");
		}
		if (Validator.isNull(form.getDuration())) {
			errors.add("activity-duration-required");
		} else if (!Validator.isNumber(form.getDuration())) {
			errors.add("activity-duration-number");
		}
		if (Validator.isNull(form.getRecipient())) {
			errors.add("activity-recipient-required");
		} else if (!Validator.isNumber(form.getRecipient())) {
			errors.add("activity-recipient-number");
		}
		if (Validator.isNull(form.getAges())) {
			errors.add("activity-ages-required");
		}
		if (!isFloat(form.getBudget())) {
			errors.add("activity-budget-number");
		}
		if (Validator.isNull(form.getPlace())) {
			errors.add("activity-place-required");
		}
		if (Validator.isNull(form.getObjectives())) {
			errors.add("activity-objectives-required");
		}
//		if (Validator.isNull(form.getEquipmentToBuy())) {
//			errors.add("activity-equipmentToBuy-required");
//		}
		if (Validator.isNull(form.getDescription())) {
			errors.add("activity-description-required");
		}
//		if (Validator.isNull(form.getPersonal())) {
//			errors.add("activity-personal-required");
//		}
//		if (Validator.isNull(form.getMaterial())) {
//			errors.add("activity-material-required");
//		}
//		if (Validator.isNull(form.getObservation())) {
//			errors.add("activity-observation-required");
//		}
		
		/*CATEGORIES*/
		
		if (Validator.isNull(form.getSectionCategory())) {
			errors.add("section-category-required");
		}
		if (Validator.isNull(form.getTypeCategory())) {
			errors.add("type-category-required");
		}
		
		return errors.isEmpty();
	}
	
	public static boolean isFloat(String number) {
		try {
			DecimalFormatUtil.getCurrencyFloat(number);
			return true;
		} catch ( Exception e) {
			return false;
		}
	}
}
