package com.martico.portlet.calEvent;

import java.util.ArrayList;
import java.util.List;

import javax.portlet.PortletURL;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.portlet.ModelAndView;
import org.springframework.web.portlet.bind.annotation.RenderMapping;
import org.springframework.web.portlet.mvc.AbstractController;

import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.service.ServiceContextFactory;
import com.liferay.portlet.calendar.model.CalEvent;
import com.liferay.portlet.calendar.service.CalEventLocalServiceUtil;
import com.martico.portlet.calEvent.model.CalEventConstants;
import com.martico.search.DefaultSearchContainer;

@Controller("calendar")
@RequestMapping({ "view", "edit" })
public class CalEventController extends AbstractController {
	private static Log log = LogFactoryUtil.getLog(CalEventController.class);

	@RenderMapping
	public ModelAndView viewMain(ModelMap model, RenderRequest request, RenderResponse response) {
		log.trace("INIT--- viewMain");
		ServiceContext serviceContext;
		try {
			serviceContext = ServiceContextFactory.getInstance(request);
			
			List<CalEvent> events = CalEventLocalServiceUtil.getEvents(serviceContext.getScopeGroupId(), CalEventConstants.getCalEventConstants(),QueryUtil.ALL_POS,QueryUtil.ALL_POS);
			DefaultSearchContainer<CalEvent> searchContainer = buildSearchContainer(request, response);
			List<CalEvent> incomingEvents;
			if (events.size()<5) {
				incomingEvents = new ArrayList<CalEvent>(events);
			} else {
				incomingEvents = events.subList(0, 5);
			}
			model.put("events", incomingEvents);
		} catch (PortalException e) {
			log.trace(e);
		} catch (SystemException e) {
			// TODO Auto-generated catch block
			log.trace(e);
		}
		return new ModelAndView("view", model);
	}
	
	private static DefaultSearchContainer<CalEvent> buildSearchContainer(RenderRequest request, RenderResponse response) {

		PortletURL iteratorURL = response.createRenderURL();
		iteratorURL.setParameter("namespace", "calendar");

		DefaultSearchContainer<CalEvent> searchContainer = new DefaultSearchContainer<CalEvent>(request, iteratorURL,null);
		searchContainer.setOrderByCol("startDate");
		searchContainer.setOrderByType("asc");
		return searchContainer;
	}
}
