package com.martico.portlet.documentLibrary;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.portlet.PortletPreferences;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.portlet.ModelAndView;
import org.springframework.web.portlet.bind.annotation.RenderMapping;
import org.springframework.web.portlet.mvc.AbstractController;

import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.servlet.SessionErrors;
import com.liferay.portal.kernel.servlet.SessionMessages;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.service.ServiceContextFactory;
import com.liferay.portlet.documentlibrary.model.DLFileEntry;
import com.liferay.portlet.documentlibrary.model.DLFolderConstants;
import com.liferay.portlet.documentlibrary.service.DLFileEntryLocalServiceUtil;
import com.martico.search.comparator.PropertyOrderByComparator;

@Controller("documentLibrary")
@RequestMapping({ "view", "edit" })
public class DocumentLibraryController extends AbstractController {
	private static Log log = LogFactoryUtil.getLog(DocumentLibraryController.class);

	@RenderMapping
	public ModelAndView viewMain(RenderRequest request, RenderResponse response) {
		log.trace("INIT--- viewMain");
		Map<String, Object> model = new HashMap<String, Object>();
		try {
			SessionMessages.clear(request);
			ServiceContext serviceContext = ServiceContextFactory.getInstance(request);
			PortletPreferences preferences = request.getPreferences();
			String strFolderId = preferences.getValue("folderId",String.valueOf(DLFolderConstants.DEFAULT_PARENT_FOLDER_ID));
			Long folderId = Long.parseLong(strFolderId);
			if (folderId==0){
				SessionMessages.add(request, "document-library-not-configured");
			} else {
				OrderByComparator orderByComparator = new PropertyOrderByComparator("title",true);
				List<DLFileEntry> fileEntries = DLFileEntryLocalServiceUtil.getFileEntries(serviceContext.getScopeGroupId(), folderId, QueryUtil.ALL_POS, QueryUtil.ALL_POS,orderByComparator);
				model.put("fileEntries", fileEntries);
			}
		} catch (PortalException e) {
			log.error("", e);
			SessionErrors.add(request, "error.occurred");
		} catch (SystemException e) {
			log.error("", e);
			SessionErrors.add(request, "error.occurred");
		}			
		return new ModelAndView("view", model);
	}
}
