package com.martico.portlet.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.User;

public class ArrayUtils {

	public static long[] stringToLongArray(String userId) {
		if (!userId.isEmpty()) {
			String[] users = userId.split(",");
			long[] data = new long[users.length];
			for (int i = 0; i < users.length; i++) {
				data[i] = Long.valueOf(users[i].trim());
			}
			return data;
		} else {
			return new long[0];
		}
	}

//	public static long[] getIdArray(List<BaseModel> userList) {
//		long[] result = new long[userList.size()];
//		for (int i = 0; i < result.length; i++) {
//			result[i] = userList.get(i).getPrimaryKeyObj();
//		}
//		return result;
//	}
	
	@SuppressWarnings("rawtypes")
	public static long[] getIdArray(List<? extends BaseModel> modelList) throws SystemException{
		long[] result = new long[modelList.size()];
		for (int i = 0; i < result.length; i++) {
			result[i] = (Long) modelList.get(i).getPrimaryKeyObj();
		}
		return result;
	}
	
	@SuppressWarnings("rawtypes")
	public static List<Object> getIdList(List<? extends BaseModel> modelList) throws SystemException{
		List<Object> result = new ArrayList<Object>();
		for (BaseModel baseModel : modelList) {
			result.add(baseModel.getPrimaryKeyObj());
		}
		return result;
	}
	
	public static String getUserIdsString(List<User> userList) throws SystemException {
		long[] userIds = getIdArray(userList);
		String result = Arrays.toString(userIds);
		result = result.substring(1,result.length()-1);
		return result;
	}
	
	@SuppressWarnings("rawtypes")
	public static String listToString(List list) {
		return list.toString().replaceAll("\\[", "").replaceAll("\\]", "");
	}
	
	public static String arrayToString(long[] userIds) {
		String result = Arrays.toString(userIds);
		result = result.substring(1,result.length()-1);
		return result;
	}

	private static long[] getIdListArray(List<Long> addUsersId) {
		long[] result = new long[addUsersId.size()];
		for (int i = 0; i < result.length; i++) {
			result[i] = addUsersId.get(i);
		}
		return result;
	}


	public static List<Object> getIdList(long[] ids) {
		List<Object> result = new ArrayList<Object>();
		for (int i = 0; i < ids.length; i++) {
			result.add(ids[i]);
		}
		return result;
	}
}
