package com.martico.portlet.util;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;


public class DecimalFormatUtil {
	private static NumberFormat formatter;
	
	static {
		
		formatter = NumberFormat.getCurrencyInstance(Locale.GERMANY);
	}
	
	public static String getCurrencyFormat(Float value) {
        return formatter.format(value);
	}
	
	public static Float getCurrencyFloat(String value) throws ParseException {
		Float newValue;
		try {
			newValue = Float.parseFloat(value);
		} catch(Exception e) {
			NumberFormat nf = NumberFormat.getNumberInstance(Locale.GERMAN);
			DecimalFormat df = (DecimalFormat)nf;
			newValue = df.parse(value).floatValue();	
		}
		return newValue;
	}
}
