package com.martico.portlet.util;

import java.io.UnsupportedEncodingException;
import java.util.Locale;
import java.util.ResourceBundle;

public class ResourceBundleUtil {
	public static String getString(Locale locale, String portletName, String key, Object[] arguments) {
		ResourceBundle resourceBundle = ResourceBundle.getBundle("com.martico.resources."+portletName+".i18n", locale);
		String message = com.liferay.util.ResourceBundleUtil.getString(resourceBundle, locale, key, arguments);
		return getUTF8String(message);
	}
	
	public static boolean hasKey(Locale locale, String portletName, String key) {
		ResourceBundle resourceBundle = ResourceBundle.getBundle("com.martico.resources."+portletName+".i18n", locale);
		return resourceBundle.containsKey(key);
	}
	
	public static String getString(Locale locale, String portletName, String key) {
		return hasKey(locale, portletName, key)?getString(locale, portletName, key, new String[0]):"";
	}

	public static String getUTF8String(String string) {
		try {
			return new String(string.getBytes("ISO-8859-1"), "UTF-8");
		} catch (UnsupportedEncodingException e) {
			throw new RuntimeException(e);
		}
	}

	public static String getLatinString(String string) {
		try {
			return new String(string.getBytes("UTF-8"), "ISO-8859-1");
		} catch (UnsupportedEncodingException e) {
			throw new RuntimeException(e);
		}
	}

}
