/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.service.base;

import com.liferay.counter.service.CounterLocalService;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.search.Indexable;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.model.PersistedModel;
import com.liferay.portal.service.BaseLocalServiceImpl;
import com.liferay.portal.service.PersistedModelLocalServiceRegistryUtil;
import com.liferay.portal.service.ResourceLocalService;
import com.liferay.portal.service.ResourceService;
import com.liferay.portal.service.UserLocalService;
import com.liferay.portal.service.UserService;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;

import com.martico.model.ActivityObjective;

import com.martico.service.ActivityLocalService;
import com.martico.service.ActivityObjectiveLocalService;
import com.martico.service.ActivityObjectiveService;
import com.martico.service.ActivityService;
import com.martico.service.persistence.ActivityObjectivePersistence;
import com.martico.service.persistence.ActivityPersistence;

import java.io.Serializable;

import java.util.List;

import javax.sql.DataSource;

/**
 * The base implementation of the activity objective local service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link com.martico.service.impl.ActivityObjectiveLocalServiceImpl}.
 * </p>
 *
 * @author edusaldana
 * @see com.martico.service.impl.ActivityObjectiveLocalServiceImpl
 * @see com.martico.service.ActivityObjectiveLocalServiceUtil
 * @generated
 */
public abstract class ActivityObjectiveLocalServiceBaseImpl
	extends BaseLocalServiceImpl implements ActivityObjectiveLocalService,
		IdentifiableBean {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link com.martico.service.ActivityObjectiveLocalServiceUtil} to access the activity objective local service.
	 */

	/**
	 * Adds the activity objective to the database. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjective the activity objective
	 * @return the activity objective that was added
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public ActivityObjective addActivityObjective(
		ActivityObjective activityObjective) throws SystemException {
		activityObjective.setNew(true);

		return activityObjectivePersistence.update(activityObjective, false);
	}

	/**
	 * Creates a new activity objective with the primary key. Does not add the activity objective to the database.
	 *
	 * @param activityObjectiveId the primary key for the new activity objective
	 * @return the new activity objective
	 */
	public ActivityObjective createActivityObjective(long activityObjectiveId) {
		return activityObjectivePersistence.create(activityObjectiveId);
	}

	/**
	 * Deletes the activity objective with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjectiveId the primary key of the activity objective
	 * @return the activity objective that was removed
	 * @throws PortalException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	public ActivityObjective deleteActivityObjective(long activityObjectiveId)
		throws PortalException, SystemException {
		return activityObjectivePersistence.remove(activityObjectiveId);
	}

	/**
	 * Deletes the activity objective from the database. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjective the activity objective
	 * @return the activity objective that was removed
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	public ActivityObjective deleteActivityObjective(
		ActivityObjective activityObjective) throws SystemException {
		return activityObjectivePersistence.remove(activityObjective);
	}

	public DynamicQuery dynamicQuery() {
		Class<?> clazz = getClass();

		return DynamicQueryFactoryUtil.forClass(ActivityObjective.class,
			clazz.getClassLoader());
	}

	/**
	 * Performs a dynamic query on the database and returns the matching rows.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return activityObjectivePersistence.findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Performs a dynamic query on the database and returns a range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @return the range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return activityObjectivePersistence.findWithDynamicQuery(dynamicQuery,
			start, end);
	}

	/**
	 * Performs a dynamic query on the database and returns an ordered range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return activityObjectivePersistence.findWithDynamicQuery(dynamicQuery,
			start, end, orderByComparator);
	}

	/**
	 * Returns the number of rows that match the dynamic query.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the number of rows that match the dynamic query
	 * @throws SystemException if a system exception occurred
	 */
	public long dynamicQueryCount(DynamicQuery dynamicQuery)
		throws SystemException {
		return activityObjectivePersistence.countWithDynamicQuery(dynamicQuery);
	}

	public ActivityObjective fetchActivityObjective(long activityObjectiveId)
		throws SystemException {
		return activityObjectivePersistence.fetchByPrimaryKey(activityObjectiveId);
	}

	/**
	 * Returns the activity objective with the primary key.
	 *
	 * @param activityObjectiveId the primary key of the activity objective
	 * @return the activity objective
	 * @throws PortalException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective getActivityObjective(long activityObjectiveId)
		throws PortalException, SystemException {
		return activityObjectivePersistence.findByPrimaryKey(activityObjectiveId);
	}

	public PersistedModel getPersistedModel(Serializable primaryKeyObj)
		throws PortalException, SystemException {
		return activityObjectivePersistence.findByPrimaryKey(primaryKeyObj);
	}

	/**
	 * Returns a range of all the activity objectives.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of activity objectives
	 * @param end the upper bound of the range of activity objectives (not inclusive)
	 * @return the range of activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> getActivityObjectives(int start, int end)
		throws SystemException {
		return activityObjectivePersistence.findAll(start, end);
	}

	/**
	 * Returns the number of activity objectives.
	 *
	 * @return the number of activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public int getActivityObjectivesCount() throws SystemException {
		return activityObjectivePersistence.countAll();
	}

	/**
	 * Updates the activity objective in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjective the activity objective
	 * @return the activity objective that was updated
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public ActivityObjective updateActivityObjective(
		ActivityObjective activityObjective) throws SystemException {
		return updateActivityObjective(activityObjective, true);
	}

	/**
	 * Updates the activity objective in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjective the activity objective
	 * @param merge whether to merge the activity objective with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	 * @return the activity objective that was updated
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public ActivityObjective updateActivityObjective(
		ActivityObjective activityObjective, boolean merge)
		throws SystemException {
		activityObjective.setNew(false);

		return activityObjectivePersistence.update(activityObjective, merge);
	}

	/**
	 * Returns the activity local service.
	 *
	 * @return the activity local service
	 */
	public ActivityLocalService getActivityLocalService() {
		return activityLocalService;
	}

	/**
	 * Sets the activity local service.
	 *
	 * @param activityLocalService the activity local service
	 */
	public void setActivityLocalService(
		ActivityLocalService activityLocalService) {
		this.activityLocalService = activityLocalService;
	}

	/**
	 * Returns the activity remote service.
	 *
	 * @return the activity remote service
	 */
	public ActivityService getActivityService() {
		return activityService;
	}

	/**
	 * Sets the activity remote service.
	 *
	 * @param activityService the activity remote service
	 */
	public void setActivityService(ActivityService activityService) {
		this.activityService = activityService;
	}

	/**
	 * Returns the activity persistence.
	 *
	 * @return the activity persistence
	 */
	public ActivityPersistence getActivityPersistence() {
		return activityPersistence;
	}

	/**
	 * Sets the activity persistence.
	 *
	 * @param activityPersistence the activity persistence
	 */
	public void setActivityPersistence(ActivityPersistence activityPersistence) {
		this.activityPersistence = activityPersistence;
	}

	/**
	 * Returns the activity objective local service.
	 *
	 * @return the activity objective local service
	 */
	public ActivityObjectiveLocalService getActivityObjectiveLocalService() {
		return activityObjectiveLocalService;
	}

	/**
	 * Sets the activity objective local service.
	 *
	 * @param activityObjectiveLocalService the activity objective local service
	 */
	public void setActivityObjectiveLocalService(
		ActivityObjectiveLocalService activityObjectiveLocalService) {
		this.activityObjectiveLocalService = activityObjectiveLocalService;
	}

	/**
	 * Returns the activity objective remote service.
	 *
	 * @return the activity objective remote service
	 */
	public ActivityObjectiveService getActivityObjectiveService() {
		return activityObjectiveService;
	}

	/**
	 * Sets the activity objective remote service.
	 *
	 * @param activityObjectiveService the activity objective remote service
	 */
	public void setActivityObjectiveService(
		ActivityObjectiveService activityObjectiveService) {
		this.activityObjectiveService = activityObjectiveService;
	}

	/**
	 * Returns the activity objective persistence.
	 *
	 * @return the activity objective persistence
	 */
	public ActivityObjectivePersistence getActivityObjectivePersistence() {
		return activityObjectivePersistence;
	}

	/**
	 * Sets the activity objective persistence.
	 *
	 * @param activityObjectivePersistence the activity objective persistence
	 */
	public void setActivityObjectivePersistence(
		ActivityObjectivePersistence activityObjectivePersistence) {
		this.activityObjectivePersistence = activityObjectivePersistence;
	}

	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Returns the resource remote service.
	 *
	 * @return the resource remote service
	 */
	public ResourceService getResourceService() {
		return resourceService;
	}

	/**
	 * Sets the resource remote service.
	 *
	 * @param resourceService the resource remote service
	 */
	public void setResourceService(ResourceService resourceService) {
		this.resourceService = resourceService;
	}

	/**
	 * Returns the resource persistence.
	 *
	 * @return the resource persistence
	 */
	public ResourcePersistence getResourcePersistence() {
		return resourcePersistence;
	}

	/**
	 * Sets the resource persistence.
	 *
	 * @param resourcePersistence the resource persistence
	 */
	public void setResourcePersistence(ResourcePersistence resourcePersistence) {
		this.resourcePersistence = resourcePersistence;
	}

	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Returns the user remote service.
	 *
	 * @return the user remote service
	 */
	public UserService getUserService() {
		return userService;
	}

	/**
	 * Sets the user remote service.
	 *
	 * @param userService the user remote service
	 */
	public void setUserService(UserService userService) {
		this.userService = userService;
	}

	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	public void afterPropertiesSet() {
		PersistedModelLocalServiceRegistryUtil.register("com.martico.model.ActivityObjective",
			activityObjectiveLocalService);
	}

	public void destroy() {
		PersistedModelLocalServiceRegistryUtil.unregister(
			"com.martico.model.ActivityObjective");
	}

	/**
	 * Returns the Spring bean ID for this bean.
	 *
	 * @return the Spring bean ID for this bean
	 */
	public String getBeanIdentifier() {
		return _beanIdentifier;
	}

	/**
	 * Sets the Spring bean ID for this bean.
	 *
	 * @param beanIdentifier the Spring bean ID for this bean
	 */
	public void setBeanIdentifier(String beanIdentifier) {
		_beanIdentifier = beanIdentifier;
	}

	public Object invokeMethod(String name, String[] parameterTypes,
		Object[] arguments) throws Throwable {
		return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
	}

	protected Class<?> getModelClass() {
		return ActivityObjective.class;
	}

	protected String getModelClassName() {
		return ActivityObjective.class.getName();
	}

	/**
	 * Performs an SQL query.
	 *
	 * @param sql the sql query
	 */
	protected void runSQL(String sql) throws SystemException {
		try {
			DataSource dataSource = activityObjectivePersistence.getDataSource();

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql, new int[0]);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = ActivityLocalService.class)
	protected ActivityLocalService activityLocalService;
	@BeanReference(type = ActivityService.class)
	protected ActivityService activityService;
	@BeanReference(type = ActivityPersistence.class)
	protected ActivityPersistence activityPersistence;
	@BeanReference(type = ActivityObjectiveLocalService.class)
	protected ActivityObjectiveLocalService activityObjectiveLocalService;
	@BeanReference(type = ActivityObjectiveService.class)
	protected ActivityObjectiveService activityObjectiveService;
	@BeanReference(type = ActivityObjectivePersistence.class)
	protected ActivityObjectivePersistence activityObjectivePersistence;
	@BeanReference(type = CounterLocalService.class)
	protected CounterLocalService counterLocalService;
	@BeanReference(type = ResourceLocalService.class)
	protected ResourceLocalService resourceLocalService;
	@BeanReference(type = ResourceService.class)
	protected ResourceService resourceService;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserLocalService.class)
	protected UserLocalService userLocalService;
	@BeanReference(type = UserService.class)
	protected UserService userService;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private String _beanIdentifier;
	private ActivityObjectiveLocalServiceClpInvoker _clpInvoker = new ActivityObjectiveLocalServiceClpInvoker();
}