/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.martico.service.persistence;

import com.liferay.portal.NoSuchModelException;
import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.BatchSessionUtil;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import com.martico.NoSuchActivityObjectiveException;

import com.martico.model.ActivityObjective;
import com.martico.model.impl.ActivityObjectiveImpl;
import com.martico.model.impl.ActivityObjectiveModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the activity objective service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author edusaldana
 * @see ActivityObjectivePersistence
 * @see ActivityObjectiveUtil
 * @generated
 */
public class ActivityObjectivePersistenceImpl extends BasePersistenceImpl<ActivityObjective>
	implements ActivityObjectivePersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link ActivityObjectiveUtil} to access the activity objective persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = ActivityObjectiveImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_ACTIVITY = new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED,
			ActivityObjectiveImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByActivity",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVITY =
		new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED,
			ActivityObjectiveImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByActivity",
			new String[] { Long.class.getName() },
			ActivityObjectiveModelImpl.ACTIVITYID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_ACTIVITY = new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByActivity",
			new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED,
			ActivityObjectiveImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED,
			ActivityObjectiveImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);

	/**
	 * Caches the activity objective in the entity cache if it is enabled.
	 *
	 * @param activityObjective the activity objective
	 */
	public void cacheResult(ActivityObjective activityObjective) {
		EntityCacheUtil.putResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveImpl.class, activityObjective.getPrimaryKey(),
			activityObjective);

		activityObjective.resetOriginalValues();
	}

	/**
	 * Caches the activity objectives in the entity cache if it is enabled.
	 *
	 * @param activityObjectives the activity objectives
	 */
	public void cacheResult(List<ActivityObjective> activityObjectives) {
		for (ActivityObjective activityObjective : activityObjectives) {
			if (EntityCacheUtil.getResult(
						ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
						ActivityObjectiveImpl.class,
						activityObjective.getPrimaryKey()) == null) {
				cacheResult(activityObjective);
			}
			else {
				activityObjective.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all activity objectives.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(ActivityObjectiveImpl.class.getName());
		}

		EntityCacheUtil.clearCache(ActivityObjectiveImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the activity objective.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(ActivityObjective activityObjective) {
		EntityCacheUtil.removeResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveImpl.class, activityObjective.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@Override
	public void clearCache(List<ActivityObjective> activityObjectives) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (ActivityObjective activityObjective : activityObjectives) {
			EntityCacheUtil.removeResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
				ActivityObjectiveImpl.class, activityObjective.getPrimaryKey());
		}
	}

	/**
	 * Creates a new activity objective with the primary key. Does not add the activity objective to the database.
	 *
	 * @param activityObjectiveId the primary key for the new activity objective
	 * @return the new activity objective
	 */
	public ActivityObjective create(long activityObjectiveId) {
		ActivityObjective activityObjective = new ActivityObjectiveImpl();

		activityObjective.setNew(true);
		activityObjective.setPrimaryKey(activityObjectiveId);

		return activityObjective;
	}

	/**
	 * Removes the activity objective with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param activityObjectiveId the primary key of the activity objective
	 * @return the activity objective that was removed
	 * @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective remove(long activityObjectiveId)
		throws NoSuchActivityObjectiveException, SystemException {
		return remove(Long.valueOf(activityObjectiveId));
	}

	/**
	 * Removes the activity objective with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the activity objective
	 * @return the activity objective that was removed
	 * @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public ActivityObjective remove(Serializable primaryKey)
		throws NoSuchActivityObjectiveException, SystemException {
		Session session = null;

		try {
			session = openSession();

			ActivityObjective activityObjective = (ActivityObjective)session.get(ActivityObjectiveImpl.class,
					primaryKey);

			if (activityObjective == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchActivityObjectiveException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(activityObjective);
		}
		catch (NoSuchActivityObjectiveException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected ActivityObjective removeImpl(ActivityObjective activityObjective)
		throws SystemException {
		activityObjective = toUnwrappedModel(activityObjective);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.delete(session, activityObjective);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		clearCache(activityObjective);

		return activityObjective;
	}

	@Override
	public ActivityObjective updateImpl(
		com.martico.model.ActivityObjective activityObjective, boolean merge)
		throws SystemException {
		activityObjective = toUnwrappedModel(activityObjective);

		boolean isNew = activityObjective.isNew();

		ActivityObjectiveModelImpl activityObjectiveModelImpl = (ActivityObjectiveModelImpl)activityObjective;

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.update(session, activityObjective, merge);

			activityObjective.setNew(false);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !ActivityObjectiveModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((activityObjectiveModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVITY.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						Long.valueOf(activityObjectiveModelImpl.getOriginalActivityId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ACTIVITY, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVITY,
					args);

				args = new Object[] {
						Long.valueOf(activityObjectiveModelImpl.getActivityId())
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_ACTIVITY, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVITY,
					args);
			}
		}

		EntityCacheUtil.putResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
			ActivityObjectiveImpl.class, activityObjective.getPrimaryKey(),
			activityObjective);

		return activityObjective;
	}

	protected ActivityObjective toUnwrappedModel(
		ActivityObjective activityObjective) {
		if (activityObjective instanceof ActivityObjectiveImpl) {
			return activityObjective;
		}

		ActivityObjectiveImpl activityObjectiveImpl = new ActivityObjectiveImpl();

		activityObjectiveImpl.setNew(activityObjective.isNew());
		activityObjectiveImpl.setPrimaryKey(activityObjective.getPrimaryKey());

		activityObjectiveImpl.setActivityObjectiveId(activityObjective.getActivityObjectiveId());
		activityObjectiveImpl.setName(activityObjective.getName());
		activityObjectiveImpl.setActivityId(activityObjective.getActivityId());

		return activityObjectiveImpl;
	}

	/**
	 * Returns the activity objective with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the activity objective
	 * @return the activity objective
	 * @throws com.liferay.portal.NoSuchModelException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public ActivityObjective findByPrimaryKey(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return findByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Returns the activity objective with the primary key or throws a {@link com.martico.NoSuchActivityObjectiveException} if it could not be found.
	 *
	 * @param activityObjectiveId the primary key of the activity objective
	 * @return the activity objective
	 * @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective findByPrimaryKey(long activityObjectiveId)
		throws NoSuchActivityObjectiveException, SystemException {
		ActivityObjective activityObjective = fetchByPrimaryKey(activityObjectiveId);

		if (activityObjective == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					activityObjectiveId);
			}

			throw new NoSuchActivityObjectiveException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				activityObjectiveId);
		}

		return activityObjective;
	}

	/**
	 * Returns the activity objective with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the activity objective
	 * @return the activity objective, or <code>null</code> if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public ActivityObjective fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		return fetchByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Returns the activity objective with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param activityObjectiveId the primary key of the activity objective
	 * @return the activity objective, or <code>null</code> if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective fetchByPrimaryKey(long activityObjectiveId)
		throws SystemException {
		ActivityObjective activityObjective = (ActivityObjective)EntityCacheUtil.getResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
				ActivityObjectiveImpl.class, activityObjectiveId);

		if (activityObjective == _nullActivityObjective) {
			return null;
		}

		if (activityObjective == null) {
			Session session = null;

			boolean hasException = false;

			try {
				session = openSession();

				activityObjective = (ActivityObjective)session.get(ActivityObjectiveImpl.class,
						Long.valueOf(activityObjectiveId));
			}
			catch (Exception e) {
				hasException = true;

				throw processException(e);
			}
			finally {
				if (activityObjective != null) {
					cacheResult(activityObjective);
				}
				else if (!hasException) {
					EntityCacheUtil.putResult(ActivityObjectiveModelImpl.ENTITY_CACHE_ENABLED,
						ActivityObjectiveImpl.class, activityObjectiveId,
						_nullActivityObjective);
				}

				closeSession(session);
			}
		}

		return activityObjective;
	}

	/**
	 * Returns all the activity objectives where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @return the matching activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findByActivity(long activityId)
		throws SystemException {
		return findByActivity(activityId, QueryUtil.ALL_POS, QueryUtil.ALL_POS,
			null);
	}

	/**
	 * Returns a range of all the activity objectives where activityId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param activityId the activity ID
	 * @param start the lower bound of the range of activity objectives
	 * @param end the upper bound of the range of activity objectives (not inclusive)
	 * @return the range of matching activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findByActivity(long activityId, int start,
		int end) throws SystemException {
		return findByActivity(activityId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the activity objectives where activityId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param activityId the activity ID
	 * @param start the lower bound of the range of activity objectives
	 * @param end the upper bound of the range of activity objectives (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findByActivity(long activityId, int start,
		int end, OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_ACTIVITY;
			finderArgs = new Object[] { activityId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_ACTIVITY;
			finderArgs = new Object[] { activityId, start, end, orderByComparator };
		}

		List<ActivityObjective> list = (List<ActivityObjective>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (ActivityObjective activityObjective : list) {
				if ((activityId != activityObjective.getActivityId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(2);
			}

			query.append(_SQL_SELECT_ACTIVITYOBJECTIVE_WHERE);

			query.append(_FINDER_COLUMN_ACTIVITY_ACTIVITYID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(activityId);

				list = (List<ActivityObjective>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first activity objective in the ordered set where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching activity objective
	 * @throws com.martico.NoSuchActivityObjectiveException if a matching activity objective could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective findByActivity_First(long activityId,
		OrderByComparator orderByComparator)
		throws NoSuchActivityObjectiveException, SystemException {
		ActivityObjective activityObjective = fetchByActivity_First(activityId,
				orderByComparator);

		if (activityObjective != null) {
			return activityObjective;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("activityId=");
		msg.append(activityId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchActivityObjectiveException(msg.toString());
	}

	/**
	 * Returns the first activity objective in the ordered set where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching activity objective, or <code>null</code> if a matching activity objective could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective fetchByActivity_First(long activityId,
		OrderByComparator orderByComparator) throws SystemException {
		List<ActivityObjective> list = findByActivity(activityId, 0, 1,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last activity objective in the ordered set where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching activity objective
	 * @throws com.martico.NoSuchActivityObjectiveException if a matching activity objective could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective findByActivity_Last(long activityId,
		OrderByComparator orderByComparator)
		throws NoSuchActivityObjectiveException, SystemException {
		ActivityObjective activityObjective = fetchByActivity_Last(activityId,
				orderByComparator);

		if (activityObjective != null) {
			return activityObjective;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("activityId=");
		msg.append(activityId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchActivityObjectiveException(msg.toString());
	}

	/**
	 * Returns the last activity objective in the ordered set where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching activity objective, or <code>null</code> if a matching activity objective could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective fetchByActivity_Last(long activityId,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByActivity(activityId);

		List<ActivityObjective> list = findByActivity(activityId, count - 1,
				count, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the activity objectives before and after the current activity objective in the ordered set where activityId = &#63;.
	 *
	 * @param activityObjectiveId the primary key of the current activity objective
	 * @param activityId the activity ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next activity objective
	 * @throws com.martico.NoSuchActivityObjectiveException if a activity objective with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public ActivityObjective[] findByActivity_PrevAndNext(
		long activityObjectiveId, long activityId,
		OrderByComparator orderByComparator)
		throws NoSuchActivityObjectiveException, SystemException {
		ActivityObjective activityObjective = findByPrimaryKey(activityObjectiveId);

		Session session = null;

		try {
			session = openSession();

			ActivityObjective[] array = new ActivityObjectiveImpl[3];

			array[0] = getByActivity_PrevAndNext(session, activityObjective,
					activityId, orderByComparator, true);

			array[1] = activityObjective;

			array[2] = getByActivity_PrevAndNext(session, activityObjective,
					activityId, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected ActivityObjective getByActivity_PrevAndNext(Session session,
		ActivityObjective activityObjective, long activityId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_ACTIVITYOBJECTIVE_WHERE);

		query.append(_FINDER_COLUMN_ACTIVITY_ACTIVITYID_2);

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(activityId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(activityObjective);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<ActivityObjective> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Returns all the activity objectives.
	 *
	 * @return the activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the activity objectives.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of activity objectives
	 * @param end the upper bound of the range of activity objectives (not inclusive)
	 * @return the range of activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findAll(int start, int end)
		throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the activity objectives.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of activity objectives
	 * @param end the upper bound of the range of activity objectives (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public List<ActivityObjective> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		FinderPath finderPath = null;
		Object[] finderArgs = new Object[] { start, end, orderByComparator };

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<ActivityObjective> list = (List<ActivityObjective>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_ACTIVITYOBJECTIVE);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_ACTIVITYOBJECTIVE;
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (orderByComparator == null) {
					list = (List<ActivityObjective>)QueryUtil.list(q,
							getDialect(), start, end, false);

					Collections.sort(list);
				}
				else {
					list = (List<ActivityObjective>)QueryUtil.list(q,
							getDialect(), start, end);
				}
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(finderPath, finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(finderPath, finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the activity objectives where activityId = &#63; from the database.
	 *
	 * @param activityId the activity ID
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByActivity(long activityId) throws SystemException {
		for (ActivityObjective activityObjective : findByActivity(activityId)) {
			remove(activityObjective);
		}
	}

	/**
	 * Removes all the activity objectives from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	public void removeAll() throws SystemException {
		for (ActivityObjective activityObjective : findAll()) {
			remove(activityObjective);
		}
	}

	/**
	 * Returns the number of activity objectives where activityId = &#63;.
	 *
	 * @param activityId the activity ID
	 * @return the number of matching activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public int countByActivity(long activityId) throws SystemException {
		Object[] finderArgs = new Object[] { activityId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_ACTIVITY,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_ACTIVITYOBJECTIVE_WHERE);

			query.append(_FINDER_COLUMN_ACTIVITY_ACTIVITYID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(activityId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_ACTIVITY,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Returns the number of activity objectives.
	 *
	 * @return the number of activity objectives
	 * @throws SystemException if a system exception occurred
	 */
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_ACTIVITYOBJECTIVE);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the activity objective persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.com.martico.model.ActivityObjective")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<ActivityObjective>> listenersList = new ArrayList<ModelListener<ActivityObjective>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<ActivityObjective>)InstanceFactory.newInstance(
							listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(ActivityObjectiveImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	@BeanReference(type = ActivityPersistence.class)
	protected ActivityPersistence activityPersistence;
	@BeanReference(type = ActivityObjectivePersistence.class)
	protected ActivityObjectivePersistence activityObjectivePersistence;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private static final String _SQL_SELECT_ACTIVITYOBJECTIVE = "SELECT activityObjective FROM ActivityObjective activityObjective";
	private static final String _SQL_SELECT_ACTIVITYOBJECTIVE_WHERE = "SELECT activityObjective FROM ActivityObjective activityObjective WHERE ";
	private static final String _SQL_COUNT_ACTIVITYOBJECTIVE = "SELECT COUNT(activityObjective) FROM ActivityObjective activityObjective";
	private static final String _SQL_COUNT_ACTIVITYOBJECTIVE_WHERE = "SELECT COUNT(activityObjective) FROM ActivityObjective activityObjective WHERE ";
	private static final String _FINDER_COLUMN_ACTIVITY_ACTIVITYID_2 = "activityObjective.activityId = ?";
	private static final String _ORDER_BY_ENTITY_ALIAS = "activityObjective.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No ActivityObjective exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No ActivityObjective exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(ActivityObjectivePersistenceImpl.class);
	private static ActivityObjective _nullActivityObjective = new ActivityObjectiveImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<ActivityObjective> toCacheModel() {
				return _nullActivityObjectiveCacheModel;
			}
		};

	private static CacheModel<ActivityObjective> _nullActivityObjectiveCacheModel =
		new CacheModel<ActivityObjective>() {
			public ActivityObjective toEntityModel() {
				return _nullActivityObjective;
			}
		};
}