package com.martico.service.search;

import com.liferay.portal.kernel.search.SearchContext;

import java.util.ArrayList;
import java.util.Date;


public class ActivitySearchContext extends SearchContext {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4861710240871106205L;
	private String name;
	private Date startDate;
	private Date endDate;
	private long[] activityIds;

	// ENUMS

	// ENTITIES

	public ActivitySearchContext() {
		super();
		this.name = "";
		this.startDate = new Date();
		this.endDate = new Date();
		super.setAndSearch(true);
		super.setCategoryIds(new long[0]);
		
		
	}

	public ActivitySearchContext(String name, Date startDate, Date endDate, String keywords, long[] categoryIdsArray,
			boolean andSearch) {
		super();
		this.name = name;
		this.startDate = startDate;
		this.endDate = endDate;
		super.setKeywords(keywords);
		super.setAndSearch(andSearch);
		super.setCategoryIds(categoryIdsArray);
	}

	public ActivitySearchContext(String title, Date startDate, Date endDate, String keywords, long[] categoryIdsArray,
			boolean andSearch, long[] activityIds) {
		this(title, startDate, endDate, keywords, categoryIdsArray, andSearch);
		setActivityIds(activityIds);
	}

	public static long[] buildCategoryIds(long section, long type) {
		ArrayList<Long> categoryIds = new ArrayList<Long>();
		if (section != 0) {
			categoryIds.add(section);
		}
		if (type != 0) {
			categoryIds.add(type);
		}

		long[] categoryIdsArray = new long[categoryIds.size()];
		for (int i = 0; i < categoryIdsArray.length; i++) {
			categoryIdsArray[i] = categoryIds.get(i);
		}
		return categoryIdsArray;
	}

	public String getName() {
		return name;
	}

	public long[] getActivityIds() {
		return activityIds;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setActivityIds(long[] activityIds) {
		this.activityIds = activityIds;
	}

	public Date getStartDate() {
		return startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}
}
